// handlebars context
var context = {
  products: []
};

function setupData() {
  // LeanCloud - 查询
  // https://leancloud.cn/docs/leanstorage_guide-js.html#查询
  var query = new AV.Query('Components');
  query.include('owner');
  query.descending('createdAt');
  query.find().then(function (products) {
    products.forEach(function(product) {
      var productTitle = product.get('name');
      var productDescription = product.get('description');
      var releaseTime = (product.createdAt.getMonth() + 1) + '/' + product.createdAt.getDate() + '/' +  product.createdAt.getFullYear();
      var ownerUsername = product.get('owner').get('username');
      var objectId = product.get('objectId')
      var productImageUrl = './../brick.png'
      // handlebars context
      context.products.push({
        productImageUrl,
        productTitle,
        productDescription,
        ownerUsername,
        releaseTime,
        objectId
      });
    });

    // use handlebars to update html
    var source = $("#products-list").html();
    var template = Handlebars.compile(source);
    var html = template(context);
    $('.products-detail').html(html);

  }).catch(function(error) {
    alert(JSON.stringify(error));
  });
};

function logout() {
  AV.User.logOut();
  window.location.href = "./../login/login.html";
};

$(function() {
  if (isCurrentUser()) {
    setupData();
  } else {
    window.location.href = "./../login/login.html";
  }
});
