var Product = AV.Object.extend('Product');

function releaseNewPage(metadata) {
  // LeanCloud - 当前用户
  // https://leancloud.cn/docs/leanstorage_guide-js.html#当前用户
  var currentUser = AV.User.current();

  // https://leancloud.cn/docs/leanstorage_guide-js.html#数据类型
  var product = new Product();
  product.set('title', metadata.layout.attributes.props['page-title']);
  product.set('description', metadata.layout.attributes.props['page-description']);
  product.set('layout', metadata.layout);
  product.set('pageSetting', metadata.page);
  product.set('owner', AV.User.current());
  // product.set('image', avFile);
  product.save().then(function() {
    window.location.href = "./../products-list/products-list.html";
  }, function(error) {
    alert(JSON.stringify(error));
  });
};

function getPages(callback) {
  var query = new AV.Query('Components');
  query.find().then(function(products) {
    let pageComponent = {}
    let cmps = []
    products.forEach(function(product) {
      if (product.get('type') === 'pageTemplate') {
        pageComponent = product.get('metadata')
      } else {
        cmps.push(product.get('metadata'))
      }
    })
    callback(pageComponent, [{
      "label": "标准",
      "components": cmps
    }], {})
  })
};
