
function getPages(callback) {
  var query = new AV.Query('Product');
  let objectIdKey = window.location.search.replace(/[\?]/, '')
  let objectId = objectIdKey.split('=')[1]
  
  // pageSource
  query.get(objectId, {
    success: function(obj) {
      var pageSource = obj.get('pageSetting');
      // Components
      var query = new AV.Query('Components');
      query.find().then(function (products) {
        let pageComponent = {}
        let cmps = []
        products.forEach(function(product) {
          if (product.get('type') === 'pageTemplate') {
            pageComponent = product.get('metadata')
          } else {
            cmps.push(product.get('metadata'))
          }
        })
        callback(pageComponent,  [{
          "label": "标准",
          "components": cmps
        }], pageSource)
      })
    },
    error: function(obj, err) {
      console.log(err.message);
    }
  })
};

function releaseNewPage(metadata) {
  var query = new AV.Query('Product');
  let objectIdKey = window.location.search.replace(/[\?]/, '')
  let objectId = objectIdKey.split('=')[1]
  
  query.get(objectId, {
    success: function(obj) {
      obj.set('title', metadata.layout.attributes.props['page-title']);
      obj.set('description', metadata.layout.attributes.props['page-description']);
      obj.set('layout', metadata.layout);
      obj.set('pageSetting', metadata.page);
      obj.save().then(function() {
        window.location.href = "./../products-list/products-list.html";
      }, function(error) {
        alert(JSON.stringify(error));
      });
    },
    error: function(obj, err) {
      console.log(err.message);
    }
  })
};