var path = require('path')
var utils = require('./utils')
var webpack = require('webpack')
var config = require('./config')
var merge = require('webpack-merge')
var baseWebpackConfig = require('./webpack.base.conf')
var CopyWebpackPlugin = require('copy-webpack-plugin')
var ExtractTextPlugin = require('extract-text-webpack-plugin')
var OptimizeCSSPlugin = require('optimize-css-assets-webpack-plugin')
var externals = require('./externals')
var ExtractTextPlugin = require('extract-text-webpack-plugin')
var HtmlWebpackPlugin = require('html-webpack-plugin')

var buildOptions = config.dev
var env = buildOptions.env

var webpackConfig = merge(baseWebpackConfig, {
  entry: {
    app: './app/index.js'
  },

  module: {
    rules: utils.styleLoaders({
      sourceMap: buildOptions.productionSourceMap,
      extract: true
    })
  },

  devtool: buildOptions.productionSourceMap ? '#source-map' : false,

  output: {
    filename: utils.assetsPath('index.js'),
    path: path.resolve(__dirname, '../app/dist')
  },

  plugins: [
    new webpack.DefinePlugin({
      'process.env': env
    }),

    // extract css into its own file
    new ExtractTextPlugin({
      filename: utils.assetsPath('[name].css')
    })
  ]
})

module.exports = webpackConfig
