'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _utils = require('../../../../utils');

var _utils2 = _interopRequireDefault(_utils);

require('../../../../../src/components/properties/basis/events-editor/index.css');

require('../../../../../src/components/properties/basis/events-editor/transfer.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = function (_Component) {
  (0, _inherits3.default)(_default, _Component);

  function _default(props) {
    (0, _classCallCheck3.default)(this, _default);

    var _this = (0, _possibleConstructorReturn3.default)(this, (_default.__proto__ || (0, _getPrototypeOf2.default)(_default)).call(this, props));

    _this.state = {
      selectedActiveCmpEvents: {},
      selectedTargetEvent: {},
      selectedActiveCmp: {},
      selectedActiveCmpEvent: {},
      eventParams: {}
    };
    return _this;
  }

  (0, _createClass3.default)(_default, [{
    key: 'onEventItemSelected',
    value: function onEventItemSelected(e, events) {
      var newState = (0, _extends3.default)({}, this.state, { selectedTargetEvent: events });
      this.setState(newState);
      this.props.onChange(newState);
    }
  }, {
    key: 'onActiveCmpEventsItemSelected',
    value: function onActiveCmpEventsItemSelected(e, events) {
      var newState = (0, _extends3.default)({}, this.state, { selectedActiveCmpEvent: events });
      this.setState(newState);
      this.props.onChange(newState);
    }
  }, {
    key: 'onActiveCmpSelected',
    value: function onActiveCmpSelected(e, cmp) {
      var _props$pageState$cmps = this.props['pageState'].cmpsEvents,
          cmpsEvents = _props$pageState$cmps === undefined ? {} : _props$pageState$cmps;

      var newState = (0, _extends3.default)({}, this.state, {
        'selectedActiveCmpEvents': cmpsEvents[cmp.classId] || [],
        'selectedActiveCmp': cmp
      });
      this.setState(newState);
      this.props.onChange(newState);
    }
  }, {
    key: 'onEventParamsChange',
    value: function onEventParamsChange(e) {
      var paramsStr = e.target.value;
      var paramsObj = {};
      try {
        paramsObj = JSON.parse(paramsStr);
      } catch (e) {
        console.error('事件参数非标准JSON格式');
      }
      var newState = (0, _extends3.default)({}, this.state, {
        'eventParams': paramsObj
      });
      this.setState(newState);
      this.props.onChange(newState);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          pageState = _props.pageState,
          targetClassId = _props.targetClassId,
          targetEvents = _props.targetEvents;
      var cmpTubStateSetting = pageState.cmpTubStateSetting;

      var standardPageSource = _utils2.default.toStandardPageSource(cmpTubStateSetting.toJS(), pageState);

      var activeComponents = [];
      var _standardPageSource$c = standardPageSource.componentList,
          componentList = _standardPageSource$c === undefined ? [] : _standardPageSource$c,
          _standardPageSource$p = standardPageSource.pageSettings,
          pageSettings = _standardPageSource$p === undefined ? {} : _standardPageSource$p;


      activeComponents.push({
        'id': pageSettings.id,
        'classId': pageSettings.classId,
        'name': pageSettings.name,
        'label': '\u9875\u9762 (' + pageSettings.name + ')'
      });

      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = (0, _getIterator3.default)(componentList), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var _ref2 = _step.value;
          var classId = _ref2.classId,
              id = _ref2.id;

          var metadata = pageState.cmpsMetadatas[classId];
          activeComponents.push({
            id: id,
            classId: classId,
            'name': metadata.name,
            'label': metadata.label + ' (' + metadata.name + ')'
          });
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      var _state = this.state,
          _state$selectedActive = _state.selectedActiveCmpEvents,
          selectedActiveCmpEvents = _state$selectedActive === undefined ? {} : _state$selectedActive,
          _state$selectedTarget = _state.selectedTargetEvent,
          selectedTargetEvent = _state$selectedTarget === undefined ? {} : _state$selectedTarget,
          _state$selectedActive2 = _state.selectedActiveCmp,
          selectedActiveCmp = _state$selectedActive2 === undefined ? {} : _state$selectedActive2,
          _state$selectedActive3 = _state.selectedActiveCmpEvent,
          selectedActiveCmpEvent = _state$selectedActive3 === undefined ? {} : _state$selectedActive3,
          _state$eventParams = _state.eventParams,
          eventParams = _state$eventParams === undefined ? {} : _state$eventParams;


      return _react2.default.createElement(
        'div',
        { className: 'pg-events-picker' },
        _react2.default.createElement(
          'div',
          { className: 'pg-pep-events-list transfer-list' },
          _react2.default.createElement(
            'div',
            { className: 'transfer-list__text' },
            '\u7EC4\u4EF6\u53EF\u7F16\u8F91\u4E8B\u4EF6'
          ),
          _react2.default.createElement('div', { className: 'transfer-list__text-bottom' }),
          _react2.default.createElement(
            'div',
            { className: 'transfer-list__body' },
            (0, _keys2.default)(targetEvents).map(function (eKey) {
              var events = targetEvents[eKey];
              return _react2.default.createElement(
                'div',
                { className: "pg-pep-events-item transfer-list__item" + (selectedTargetEvent.name === eKey ? ' active' : ''),
                  onClick: function onClick(e) {
                    _this2.onEventItemSelected(e, (0, _extends3.default)(events, { name: eKey }));
                  } },
                _react2.default.createElement(
                  'span',
                  { className: 'transfer-list__item__text' },
                  events.label,
                  ' (',
                  eKey,
                  ')'
                )
              );
            })
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'pg-pep-cmp-picker' },
          _react2.default.createElement(
            'div',
            { className: 'pg-pep-cmpp-cmps-list transfer-list' },
            _react2.default.createElement(
              'div',
              { className: 'transfer-list__text' },
              '\u5F53\u524D\u5DE5\u4F5C\u53F0\u4E2D\u521D\u59CB\u5316\u7684\u7EC4\u4EF6'
            ),
            _react2.default.createElement('div', { className: 'transfer-list__text-bottom' }),
            _react2.default.createElement(
              'div',
              { className: 'transfer-list__body' },
              activeComponents.map(function (cmp) {
                var classId = cmp.classId,
                    name = cmp.name,
                    label = cmp.label,
                    id = cmp.id;

                return _react2.default.createElement(
                  'div',
                  { className: "pg-pep-cmpp-item transfer-list__item" + (selectedActiveCmp.id === id ? ' active' : ''),
                    onClick: function onClick(e) {
                      _this2.onActiveCmpSelected(e, cmp);
                    } },
                  _react2.default.createElement(
                    'span',
                    { className: 'transfer-list__item__text' },
                    label
                  )
                );
              })
            )
          ),
          _react2.default.createElement(
            'div',
            { className: 'pg-pep-cmpp-cmps-events-list transfer-list' },
            _react2.default.createElement(
              'div',
              { className: 'transfer-list__text' },
              '\u7EC4\u4EF6\u53EF\u5173\u8054\u7684\u4E8B\u4EF6'
            ),
            _react2.default.createElement('div', { className: 'transfer-list__text-bottom' }),
            _react2.default.createElement(
              'div',
              { className: 'transfer-list__body' },
              (0, _keys2.default)(selectedActiveCmpEvents).map(function (eKey) {
                var events = selectedActiveCmpEvents[eKey];
                return _react2.default.createElement(
                  'div',
                  { className: "pg-pep-pep-cmpp-events-item transfer-list__item" + (selectedActiveCmpEvent.name === eKey ? ' active' : ''),
                    onClick: function onClick(e) {
                      _this2.onActiveCmpEventsItemSelected(e, (0, _extends3.default)(events, { name: eKey }));
                    } },
                  _react2.default.createElement(
                    'span',
                    { className: 'transfer-list__item__text' },
                    events.label,
                    ' (',
                    eKey,
                    ')'
                  ),
                  selectedActiveCmpEvent.name === eKey ? _react2.default.createElement(
                    'div',
                    { className: 'form-item' },
                    _react2.default.createElement(
                      'div',
                      { className: 'form-item__control form-item__control_has-info' },
                      _react2.default.createElement(
                        'span',
                        { className: 'u-textarea' },
                        _react2.default.createElement(
                          'textarea',
                          {
                            className: 'u-textarea__element pg-pep-event-params-editor',
                            placeholder: '\u4E8B\u4EF6\u53C2\u6570',
                            onChange: _this2.onEventParamsChange.bind(_this2) },
                          (0, _stringify2.default)(eventParams)
                        ),
                        _react2.default.createElement('span', { className: 'form-item__bottom-line' }),
                        _react2.default.createElement(
                          'span',
                          { className: 'u-textarea__tuozhuai-icon' },
                          _react2.default.createElement('i', { className: 'u-icon pc-sys-tuozhuai-nomal-svg' }),
                          _react2.default.createElement('i', { className: 'u-icon pc-sys-tuozhuai-active-svg' })
                        )
                      )
                    )
                  ) : null
                );
              })
            )
          )
        )
      );
    }
  }]);
  return _default;
}(_react.Component);

exports.default = _default;
module.exports = exports['default'];