'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _tabItem = require('./tab-item');

var _tabItem2 = _interopRequireDefault(_tabItem);

require('../../../../../../src/components/properties/basis/tab-item-creator/TabItemList/index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = function (_Component) {
  (0, _inherits3.default)(_default, _Component);

  function _default(props) {
    (0, _classCallCheck3.default)(this, _default);

    var _this = (0, _possibleConstructorReturn3.default)(this, (_default.__proto__ || (0, _getPrototypeOf2.default)(_default)).call(this, props));

    _this.state = {};
    return _this;
  }

  (0, _createClass3.default)(_default, [{
    key: 'onItemUpdate',
    value: function onItemUpdate(targetValue, _ref) {
      var value = _ref.value,
          label = _ref.label,
          code = _ref.code;
      var items = this.props.items;

      items = items.map(function (item) {
        if (targetValue === item.value) {
          item = (0, _extends3.default)({}, item, { value: value, label: label, code: code });
        }
        return item;
      });
      this.props.onChange(items);
    }
  }, {
    key: 'onItemDelete',
    value: function onItemDelete(targetValue) {
      var items = this.props.items;

      items = items.filter(function (_ref2) {
        var value = _ref2.value;
        return targetValue !== value;
      });
      this.props.onChange(items);
    }
  }, {
    key: 'onItemSort',
    value: function onItemSort(targetValue, _ref3) {
      var direction = _ref3.direction;
      var items = this.props.items;


      var targetIndex = -1;
      for (var i = 0; i < items.length; i++) {
        if (items[i].value == targetValue) {
          targetIndex = i;
          break;
        }
      }

      if (direction == 'top') {
        if (targetIndex == 0) return;

        items.splice(targetIndex - 1, /* 开始删除的节点下标 */
        2, /* 向后删除2个节点 */
        items[targetIndex], /* 被前移的节点 */
        items[targetIndex - 1] /* 被后置的节点 */
        );
      } else if (direction == 'down') {
        if (targetIndex == items.length - 1) return;

        items.splice(targetIndex, 2, items[targetIndex + 1], items[targetIndex]);
      }

      this.props.onChange(items);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var items = this.props.items;


      return React.createElement(
        'div',
        { className: 'pg-prop-tab-list' },
        React.createElement(
          'ul',
          null,
          items.map(function (_ref4, index) {
            var label = _ref4.label,
                value = _ref4.value,
                code = _ref4.code;

            return React.createElement(_tabItem2.default, {
              key: value,
              label: label,
              value: value,
              code: code,
              currentIndex: index,
              onUpdate: _this2.onItemUpdate.bind(_this2),
              onDelete: _this2.onItemDelete.bind(_this2),
              onSort: _this2.onItemSort.bind(_this2),
              checkCodeRepeat: _this2.props.checkCodeRepeat
            });
          })
        )
      );
    }
  }]);
  return _default;
}(_react.Component);

exports.default = _default;
module.exports = exports['default'];