'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _TabItemList = require('./TabItemList');

var _TabItemList2 = _interopRequireDefault(_TabItemList);

var _TabItemEditor = require('./TabItemEditor');

var _TabItemEditor2 = _interopRequireDefault(_TabItemEditor);

var _select = require('../../../basis/select');

var _select2 = _interopRequireDefault(_select);

var _dropdownList = require('../../../basis/dropdown-list');

var _dropdownList2 = _interopRequireDefault(_dropdownList);

require('../../../../../src/components/properties/basis/tab-item-creator/index.css');

require('../../../../../src/components/properties/basis/tab-item-creator/tab-add-icon.png');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TabControl = function (_Component) {
  (0, _inherits3.default)(TabControl, _Component);

  function TabControl(props) {
    (0, _classCallCheck3.default)(this, TabControl);

    var _this = (0, _possibleConstructorReturn3.default)(this, (TabControl.__proto__ || (0, _getPrototypeOf2.default)(TabControl)).call(this, props));

    _this.state = {
      'showViewCreater': false
    };
    return _this;
  }

  (0, _createClass3.default)(TabControl, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          defaultValueNeedUpdate = _props.defaultValueNeedUpdate,
          _props$attributes$pro = _props['attributes']['props'].value,
          value = _props$attributes$pro === undefined ? '' : _props$attributes$pro;


      if (defaultValueNeedUpdate) {
        this.props.updateSilent({
          'defaultTab': 'is-active-first-item',
          'isActiveFirstItem': true
        });
      }
    }
  }, {
    key: 'defaultTabChangeHander',
    value: function defaultTabChangeHander(selectedItems) {
      var defaultTab = '';
      var isActiveFirstItem = false;

      if (selectedItems.length > 0) {
        defaultTab = selectedItems[0].value;
        if (defaultTab == 'is-active-first-item') {
          isActiveFirstItem = true;
        }
      }
      var selectedItemValues = selectedItems.map(function (_ref) {
        var value = _ref.value;
        return value;
      });
      var data = (0, _extends3.default)({}, this.props.data, {
        defaultTab: defaultTab, isActiveFirstItem: isActiveFirstItem
      });
      this.props.update(data);
    }
  }, {
    key: 'onTabItemsChangeHandeler',
    value: function onTabItemsChangeHandeler(tabItemList) {
      var _props$data$tabItemLi = this.props.data['tabItemList'],
          currentTabItemList = _props$data$tabItemLi === undefined ? [] : _props$data$tabItemLi;

      var nextItemValues = tabItemList.map(function (_ref2) {
        var value = _ref2.value;
        return value;
      });
      var data = (0, _extends3.default)({}, this.props.data, {
        tabItemList: tabItemList
      });

      var needRemovedItemCode = undefined;
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = (0, _getIterator3.default)(currentTabItemList), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var _ref4 = _step.value;
          var itemValue = _ref4['value'];

          if (!nextItemValues.includes(itemValue)) {
            needRemovedItemCode = itemValue;
            break; /* 一次性只可能删除一个item */
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      if (needRemovedItemCode) {
        var updateAndDisconnect = this.props.updateAndDisconnect;

        updateAndDisconnect(needRemovedItemCode, data);
      } else {
        this.props.update(data);
      }
    }
  }, {
    key: 'onEditorAddHandler',
    value: function onEditorAddHandler(_ref5) {
      var label = _ref5.label,
          value = _ref5.value,
          code = _ref5.code;

      var _ref6 = this.props.data || {},
          _ref6$tabItemList = _ref6.tabItemList,
          tabItemList = _ref6$tabItemList === undefined ? [] : _ref6$tabItemList,
          defaultTab = _ref6.defaultTab;

      tabItemList.push({ label: label, value: value, code: code });

      var data = (0, _extends3.default)({}, this.props.data, {
        tabItemList: tabItemList,
        'defaultTab': defaultTab == undefined ? value : defaultTab /* 第一次添加的tab默认值 */
      });

      this.setState({ 'showViewCreater': false });
      this.props.update(data);
    }
  }, {
    key: 'onEditorCancelHandler',
    value: function onEditorCancelHandler() {
      this.setState({ 'showViewCreater': false });
    }
  }, {
    key: 'onCreateItemHandler',
    value: function onCreateItemHandler() {
      this.setState({ 'showViewCreater': true });
    }
  }, {
    key: 'checkItemCodeRepeat',
    value: function checkItemCodeRepeat(targetCode, targetValue) {
      var _ref7 = this.props.data || {},
          _ref7$tabItemList = _ref7.tabItemList,
          tabItemList = _ref7$tabItemList === undefined ? [] : _ref7$tabItemList;

      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = (0, _getIterator3.default)(tabItemList), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var _ref9 = _step2.value;
          var code = _ref9.code,
              value = _ref9.value;

          if (targetCode == code && targetValue != value) return true;
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }

      return false;
    }
  }, {
    key: 'render',
    value: function render() {
      var _ref10 = this.props.data || {},
          _ref10$tabItemList = _ref10.tabItemList,
          tabItemList = _ref10$tabItemList === undefined ? [] : _ref10$tabItemList,
          _ref10$defaultTab = _ref10.defaultTab,
          defaultTab = _ref10$defaultTab === undefined ? '' : _ref10$defaultTab,
          _ref10$isActiveFirstI = _ref10.isActiveFirstItem,
          isActiveFirstItem = _ref10$isActiveFirstI === undefined ? false : _ref10$isActiveFirstI;

      var _props$attributes$pro2 = this.props.attributes.props,
          _props$attributes$pro3 = _props$attributes$pro2.validateStatus,
          validateStatus = _props$attributes$pro3 === undefined ? {} : _props$attributes$pro3,
          _props$attributes$pro4 = _props$attributes$pro2.validation,
          validation = _props$attributes$pro4 === undefined ? {} : _props$attributes$pro4;
      var showViewCreater = this.state.showViewCreater;

      var defaultTabItemList = [{ 'label': '第一个选项卡', 'value': 'is-active-first-item' }].concat(tabItemList);

      /* 默认选项卡选中的节点 */
      var defaultTabSelected = defaultTab ? [defaultTab] : [];

      /* 验证 */
      var errMsg = validateStatus['message'],
          valid = validateStatus.valid;


      var hasTabItemRequiredValidate = 'tabItemRequired' in validation;
      var hasDefaultTabRequiredValidate = 'required' in validation;

      var _validation$tabItemRe = validation.tabItemRequired,
          tabItemRequired = _validation$tabItemRe === undefined ? {} : _validation$tabItemRe;
      var _validation$required = validation['required'],
          defaultTabRequired = _validation$required === undefined ? {} : _validation$required;


      return React.createElement(
        'div',
        { className: 'pg-props-tab-items-controller' },
        React.createElement(
          'div',
          { className: 'ptic-item' },
          React.createElement(_dropdownList2.default, { items: defaultTabItemList, selected: defaultTabSelected, onChange: this.defaultTabChangeHander.bind(this) }),
          hasDefaultTabRequiredValidate && !defaultTabRequired.valid ? React.createElement(
            'span',
            { className: 'pg-prop-error-text' },
            defaultTabRequired.message
          ) : null
        ),
        React.createElement(
          'div',
          { className: 'ptic-item', style: { 'margin-top': '6px', 'margin-bottom': '5px' } },
          React.createElement(
            'span',
            {
              className: hasTabItemRequiredValidate ? 'pg-prop-common-label pg-prop-common-label-required' : '',
              style: { 'margin-bottom': '0' }
            },
            '\u9009\u9879\u5361'
          ),
          React.createElement('span', { onClick: this.onCreateItemHandler.bind(this), className: 'ptic-add-icon sys-icon-add' })
        ),
        React.createElement(
          'div',
          { className: 'ptic-item' },
          React.createElement(_TabItemList2.default, { items: tabItemList, onChange: this.onTabItemsChangeHandeler.bind(this), checkCodeRepeat: this.checkItemCodeRepeat.bind(this) })
        ),
        hasTabItemRequiredValidate && !tabItemRequired.valid ? React.createElement(
          'div',
          null,
          React.createElement(
            'span',
            { className: 'pg-prop-error-text' },
            tabItemRequired.message
          )
        ) : null,
        showViewCreater ? React.createElement(_TabItemEditor2.default, {
          onSaveClickHandler: this.onEditorAddHandler.bind(this),
          onCancelClickHandler: this.onEditorCancelHandler.bind(this),
          checkCodeRepeat: this.checkItemCodeRepeat.bind(this) }) : null
      );
    }
  }]);
  return TabControl;
}(_react.Component);

exports.default = TabControl;
module.exports = exports['default'];