'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

exports.default = function () {
  var http = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

  /* 需要做异步请求的配置 */
  return new _promise2.default(function (resolve, reject) {
    if (!http.length) resolve([]);

    var httpPromises = [];
    http.forEach(function (httpRequest) {
      var url = httpRequest.url,
          _httpRequest$data = httpRequest.data,
          data = _httpRequest$data === undefined ? {} : _httpRequest$data,
          _httpRequest$method = httpRequest.method,
          method = _httpRequest$method === undefined ? 'GET' : _httpRequest$method,
          _httpRequest$onComple = httpRequest.onComplete,
          onComplete = _httpRequest$onComple === undefined ? [] : _httpRequest$onComple;

      httpPromises.push(new _promise2.default(function (resolve, reject) {
        (0, _fetch2.default)({
          method: method,
          'url': (0, _filterParser2.default)(url),
          'params': (0, _filterParser.parseObjValues)(data)
        }).then(function (_ref) {
          var response = _ref['body'];
          var _iteratorNormalCompletion = true;
          var _didIteratorError = false;
          var _iteratorError = undefined;

          try {
            for (var _iterator = (0, _getIterator3.default)(onComplete), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              var _ref3 = _step.value;
              var _ref3$type = _ref3.type,
                  type = _ref3$type === undefined ? '' : _ref3$type,
                  _ref3$params = _ref3.params,
                  params = _ref3$params === undefined ? {} : _ref3$params;

              var action = httpActions[type];
              if (!action) throw new Error('Http.onComplete \u672A\u627E\u5230\u6307\u5B9Aaction: ' + type);
              response = httpActions[type](response, params);
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }

          resolve(response);
        });
      }));
    });

    _promise2.default.all(httpPromises).then(function (responses) {
      resolve(responses);
    });
  });
};

var _fetch = require('../../../../helpers/fetch');

var _fetch2 = _interopRequireDefault(_fetch);

var _filterParser = require('../../../../helpers/filterParser');

var _filterParser2 = _interopRequireDefault(_filterParser);

var _httpActions = require('./http-actions');

var httpActions = _interopRequireWildcard(_httpActions);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = exports['default'];