'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.default = function (WrappedComponent) {
  var wrappedOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var WrapperComponent = function (_React$Component) {
    (0, _inherits3.default)(WrapperComponent, _React$Component);

    function WrapperComponent(props) {
      (0, _classCallCheck3.default)(this, WrapperComponent);

      var _this = (0, _possibleConstructorReturn3.default)(this, (WrapperComponent.__proto__ || (0, _getPrototypeOf2.default)(WrapperComponent)).call(this, props));

      _this.update = function (obj) {
        /* 判断update函数存在，pgBuilder不可控因素 */
        if (_this.props.update) {
          _this.props.update(obj);
        }
      };

      _this.state = {
        'resources': {},
        'componented': false,
        'defaultValueNeedUpdate': false /* 是否需要update默认值 */
      };
      return _this;
    }

    (0, _createClass3.default)(WrapperComponent, [{
      key: 'defaultValueNeedUpdate',
      value: function defaultValueNeedUpdate() {
        var data = this.props.data;

        if (data === undefined || data == null) {
          return true;
        }
        return false;
      }
    }, {
      key: 'componentDidMount',
      value: function componentDidMount() {
        var _this2 = this;

        var _props$_metadata$http = this.props._metadata.http,
            http = _props$_metadata$http === undefined ? [] : _props$_metadata$http;

        (0, _http2.default)(http).then(function (responses) {
          var state = { 'resources': {} };
          responses.forEach(function (resp) {
            for (var key in resp) {
              state['resources'][key] = resp[key];
            }
          });
          _this2.setState((0, _extends3.default)({}, state, {
            'componented': true,
            'defaultValueNeedUpdate': _this2.defaultValueNeedUpdate()
          }));
        });
      }
    }, {
      key: 'render',
      value: function render() {
        /* 未请求到元数据前不渲染组件 */
        if (!this.state.componented) return null;

        var defaultValueNeedUpdate = this.state.defaultValueNeedUpdate;
        var _props = this.props,
            $u = _props['update'],
            _metadata = _props._metadata,
            restProps = (0, _objectWithoutProperties3.default)(_props, ['update', '_metadata']);
        var _metadata$attributes = _metadata.attributes,
            attributes = _metadata$attributes === undefined ? {} : _metadata$attributes,
            _metadata$validation = _metadata.validation,
            validation = _metadata$validation === undefined ? [] : _metadata$validation,
            _metadata$label = _metadata.label,
            label = _metadata$label === undefined ? '' : _metadata$label,
            _metadata$description = _metadata.description,
            description = _metadata$description === undefined ? [] : _metadata$description;
        var _attributes$props = attributes.props,
            props = _attributes$props === undefined ? {} : _attributes$props,
            restAttrs = (0, _objectWithoutProperties3.default)(attributes, ['props']);


        restProps = (0, _extends3.default)({}, restProps, {
          /* 把动态数据源merge进props, 传入属性组件 */
          'attributes': (0, _extends3.default)({
            'props': (0, _extends3.default)({}, (0, _filterParser.parseObjValues)(props), this.state.resources, {
              label: label,
              validation: validation,
              description: description
            })
          }, restAttrs),
          defaultValueNeedUpdate: defaultValueNeedUpdate
        });

        return _react2.default.createElement(
          'div',
          { className: 'pg-prop-wrapper' },
          _react2.default.createElement(_propCmpLabel2.default, { label: label, validation: validation, description: description }),
          _react2.default.createElement(WrappedComponent, (0, _extends3.default)({ httpResolver: _http2.default }, restProps, { update: this.update, _metadata: _metadata }))
        );
      }
    }]);
    return WrapperComponent;
  }(_react2.default.Component);

  return WrapperComponent;
};

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _http = require('./http');

var _http2 = _interopRequireDefault(_http);

var _filterParser = require('../../../helpers/filterParser');

var _filterParser2 = _interopRequireDefault(_filterParser);

var _propCmpLabel = require('../../basis/prop-cmp-label');

var _propCmpLabel2 = _interopRequireDefault(_propCmpLabel);

require('../../../../src/components/properties/http-wrapper/index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = exports['default'];