'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.installProperties = undefined;

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _text = require('./basis/text');

var _text2 = _interopRequireDefault(_text);

var _label = require('./basis/label');

var _label2 = _interopRequireDefault(_label);

var _textarea = require('./basis/textarea');

var _textarea2 = _interopRequireDefault(_textarea);

var _checkbox = require('./basis/checkbox');

var _checkbox2 = _interopRequireDefault(_checkbox);

var _checkboxList = require('./basis/checkbox-list');

var _checkboxList2 = _interopRequireDefault(_checkboxList);

var _select = require('./basis/select');

var _select2 = _interopRequireDefault(_select);

var _selectList = require('./basis/select-list');

var _selectList2 = _interopRequireDefault(_selectList);

var _richEditorText = require('./basis/rich-editor-text');

var _richEditorText2 = _interopRequireDefault(_richEditorText);

var _jsonEditor = require('./basis/json-editor');

var _jsonEditor2 = _interopRequireDefault(_jsonEditor);

var _cascadeSelector = require('./basis/cascade-selector');

var _cascadeSelector2 = _interopRequireDefault(_cascadeSelector);

var _tabItemCreator = require('./basis/tab-item-creator');

var _tabItemCreator2 = _interopRequireDefault(_tabItemCreator);

var _eventsEditor = require('./basis/events-editor');

var _eventsEditor2 = _interopRequireDefault(_eventsEditor);

var _httpWrapper = require('./http-wrapper');

var _httpWrapper2 = _interopRequireDefault(_httpWrapper);

var _validateWrapper = require('./validate-wrapper');

var _validateWrapper2 = _interopRequireDefault(_validateWrapper);

var _pageStateWrapper = require('./page-state-wrapper');

var _pageStateWrapper2 = _interopRequireDefault(_pageStateWrapper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var properties = {
  Text: _text2.default,
  Textarea: _textarea2.default,
  CheckboxList: _checkboxList2.default,
  Label: _label2.default,
  Select: _select2.default,
  SelectList: _selectList2.default,
  Checkbox: _checkbox2.default,
  RichEditorText: _richEditorText2.default,
  JsonEditor: _jsonEditor2.default,
  CascadeSelector: _cascadeSelector2.default,
  TabItemCreator: _tabItemCreator2.default,
  EventsEditor: _eventsEditor2.default
};

/* 高阶组件 */
exports.default = properties;

/*
* 遍历每一个基础组件，包裹高阶组件
* httpWrapper：处理请求
* validationWrapper 处理验证
*/

(0, _keys2.default)(properties).forEach(function (name) {
  var cmp = properties[name];
  properties[name] = (0, _httpWrapper2.default)((0, _validateWrapper2.default)((0, _pageStateWrapper2.default)(cmp)));
});

var installProperties = exports.installProperties = function installProperties(insProperties) {
  (0, _keys2.default)(insProperties).forEach(function (name) {
    properties[name] = (0, _httpWrapper2.default)((0, _validateWrapper2.default)((0, _pageStateWrapper2.default)(insProperties[name])));
  });
};