'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.installValidates = exports.injectValidatesScope = undefined;

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _required = require('./required');

var _required2 = _interopRequireDefault(_required);

var _maxLength = require('./maxLength');

var _maxLength2 = _interopRequireDefault(_maxLength);

var _format = require('./format');

var _format2 = _interopRequireDefault(_format);

var _relatedExpRequired = require('./relatedExpRequired');

var _relatedExpRequired2 = _interopRequireDefault(_relatedExpRequired);

var _comparePropDataUnique = require('./comparePropDataUnique');

var _comparePropDataUnique2 = _interopRequireDefault(_comparePropDataUnique);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var validates = {
  required: _required2.default, maxLength: _maxLength2.default, format: _format2.default, relatedExpRequired: _relatedExpRequired2.default,
  comparePropDataUnique: _comparePropDataUnique2.default
};

exports.default = validates;
var injectValidatesScope = exports.injectValidatesScope = function injectValidatesScope() {
  for (var _len = arguments.length, scope = Array(_len), _key = 0; _key < _len; _key++) {
    scope[_key] = arguments[_key];
  }

  (0, _keys2.default)(validates).forEach(function (name) {
    var oriValidate = validates[name];
    validates[name] = function () {
      for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      return oriValidate.apply(undefined, scope.concat(args));
    };
  });
};

var installValidates = exports.installValidates = function installValidates(insValidates) {
  (0, _keys2.default)(insValidates).forEach(function (name) {
    validates[name] = insValidates[name];
  });
};