'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (state) {
  var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var params = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var _ref = arguments[3];
  var filterParser = _ref.filterParser,
      filterObjValuesParser = _ref.filterObjValuesParser;
  var _params$validateRules = params.validateRules,
      validateRules = _params$validateRules === undefined ? [] : _params$validateRules;


  if (validateRules.length) {
    var res = true;

    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = (0, _getIterator3.default)(validateRules), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var rule = _step.value;

        res = filterParser(rule, { 'propData': data });
        if (!res) break;
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    if (!res) return false;
    return true;
  } else {

    /* 通用验证规则 */
    if (typeof data == null) {
      return false;
    } else if (typeof data == 'undefined') {
      return false;
    } else if ((typeof data === 'undefined' ? 'undefined' : (0, _typeof3.default)(data)) == 'object') {
      if ((0, _keys2.default)(data || {}).length) return true;
      return false;
    } else if (typeof data == 'array') {
      if (data.length) return true;
      return false;
    } else {
      return !!data;
    }
  }
};

module.exports = exports['default'];