'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.installContexts = exports.injectContextsScope = undefined;

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _queryParams = require('./queryParams');

var _queryParams2 = _interopRequireDefault(_queryParams);

var _searchParams = require('./searchParams');

var _searchParams2 = _interopRequireDefault(_searchParams);

var _urlParams = require('./urlParams');

var _urlParams2 = _interopRequireDefault(_urlParams);

var _activeComponents = require('./activeComponents');

var _activeComponents2 = _interopRequireDefault(_activeComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var contexts = {
  queryParams: _queryParams2.default,
  searchParams: _searchParams2.default,
  urlParams: _urlParams2.default,
  pageLayout: function pageLayout() {},
  pageInfo: function pageInfo() {},
  activeComponents: _activeComponents2.default
};

exports.default = contexts;
var injectContextsScope = exports.injectContextsScope = function injectContextsScope() {
  for (var _len = arguments.length, scope = Array(_len), _key = 0; _key < _len; _key++) {
    scope[_key] = arguments[_key];
  }

  (0, _keys2.default)(contexts).forEach(function (name) {
    var oriContexts = contexts[name];
    contexts[name] = function () {
      for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      return oriContexts.apply(undefined, args.concat(scope));
    };
  });
};

var installContexts = exports.installContexts = function installContexts(insContexts) {
  (0, _keys2.default)(insContexts).forEach(function (name) {
    contexts[name] = insContexts[name];
  });
};