'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

exports.default = function (request) {
  var _request = request,
      _request$url = _request.url,
      url = _request$url === undefined ? '' : _request$url,
      _request$method = _request.method,
      method = _request$method === undefined ? 'GET' : _request$method,
      _request$params = _request.params,
      params = _request$params === undefined ? {} : _request$params,
      _request$headers = _request.headers,
      headers = _request$headers === undefined ? {} : _request$headers,
      dataType = _request.dataType,
      mark = _request.mark;

  method = method.toUpperCase();

  /* 编辑 fetch API 需要的请求参数 */
  request = {
    'credentials': 'include',
    'headers': {
      'Accept': 'application/json, application/xml, text/play, text/html, *.*',
      'Content-Type': 'application/json; charset=utf-8'
    },
    'method': method

    /* 序列化 GET 请求的 url */
  };if (method === 'GET') {
    url += (url.indexOf("?") != -1 ? '&' : '?') + function (obj) {
      var result = [];
      for (var k in obj) {
        result.push(encodeURIComponent(k) + '=' + encodeURIComponent(obj[k]));
      }
      return result.join('&');
    }(params);
  } else if (headers && headers['Content-Type'] == 'application/x-www-form-urlencoded') {
    /* 序列化表单请求参数 */
    var urlSear = new URLSearchParams();
    for (var i in params) {
      urlSear.append(i, params[i]);
    }
    request.body = urlSear.toString();
  } else {
    request.body = (0, _stringify2.default)(params);
  }

  /*
  * 发送请求
  * @dataType: 根据 dataType 转化接口返回对象
  */
  return fetch(url, request).then(function (response) {
    var formatApi = dataType == 'text' ? 'text' : 'json';
    if (!response.ok) {
      response[formatApi] = function () {
        return this.text().then(function (data) {
          try {
            return JSON.parse(data);
          } catch (e) {
            return _promise2.default.reject(response);
          }
        });
      };
    }
    return response[formatApi]().then(function (json) {
      return { json: json, response: response };
    });
  }).then(function (_ref) {
    var json = _ref.json,
        response = _ref.response;

    if (!response.ok) {
      return _promise2.default.reject({ json: json, response: response });
    }
    /* 返回标准Request对象 */
    return {
      'ok': response.ok,
      'status': response.status,
      'statusText': response.statusText,
      'headers': response.headers,
      'bodyUsed': response.bodyUsed,
      'redirected': response.redirected,
      'type': response.type,
      'url': response.url,
      'body': json
    };
  });
};

var _es6Promise = require('es6-promise');

require('isomorphic-fetch');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var URLSearchParams = require('url-search-params');

module.exports = exports['default'];