'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.parseObjValues = undefined;

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _vueFilterParser = require('./vue-filter-parser');

var _ejs = require('./ejs');

var _filters = require('./filters');

var _contexts = require('../../contexts');

var _contexts2 = _interopRequireDefault(_contexts);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var parse = function parse() {
  var filterString = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var excuteContext = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  if (!filterString || typeof filterString !== 'string') {
    return filterString;
  }
  /* 转换函数类型的context成可用对象变量 */
  var basedContextsObj = excFunContextToObject(_contexts2.default);
  /* resolveFilter：获取 filter 的工厂函数 */
  (0, _extends3.default)(excuteContext, (0, _extends3.default)({ resolveFilter: _filters.resolveFilter }, basedContextsObj));
  // filterString = filterString.replace(/^\s*{{\s*|\s*}}\s*$/g, '')
  var parsedFilterString = (0, _vueFilterParser.parseText)(filterString);
  /* 使用 ejs 插件处理模板，可返回复杂对象(非字符串) */

  var _EJSCompiler = (0, _ejs.compile)('<%= ' + parsedFilterString + ' %>')(excuteContext),
      _EJSCompiler2 = (0, _slicedToArray3.default)(_EJSCompiler, 1),
      value = _EJSCompiler2[0];

  return value;
};

exports.default = parse;
var parseObjValues = exports.parseObjValues = function parseObjValues() {
  var obj = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var excuteContext = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var res = {};
  (0, _keys2.default)(obj).forEach(function (objKey) {
    res[objKey] = parse(obj[objKey], excuteContext);
  });
  return res;
};

function excFunContextToObject(contexts) {
  var resObject = {};
  (0, _keys2.default)(contexts).forEach(function (contextKey) {
    var val = typeof contexts[contextKey] === 'function' ? contexts[contextKey]() : contexts[contextKey];
    resObject[contextKey] = val;
  });
  return resObject;
}