'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

exports.default = function (modulePaths) {
  // 兼容请求单个或者多个模块
  if (typeof modulePaths === 'string') return singleModuleImport(modulePaths);else if (Object.prototype.toString.call(modulePaths) === '[object Array]') return multiModuleImport(modulePaths);else throw new Error('模块地址参数格式错误，字符串或者数组');
};

var _asyncRequire = require('./asyncRequire');

var _asyncRequire2 = _interopRequireDefault(_asyncRequire);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
* 如果传入字符串，则使用单个模块加载模式
*/
var singleModuleImport = function singleModuleImport(modulePath) {
  return (0, _asyncRequire2.default)(modulePath);
};

/*
* 如果传入数组，则使用多个模块加载模式
*/
var multiModuleImport = function multiModuleImport(modulePaths) {
  return new _promise2.default(function (resolve, reject) {
    // 创建模块异步加载的 promise 对象
    var moduleAsyncHandlers = [];
    for (var i = 0; i < modulePaths.length; i++) {
      moduleAsyncHandlers.push((0, _asyncRequire2.default)(modulePaths[i]));
    }

    // 加载所有的模块
    _promise2.default.all(moduleAsyncHandlers).then(function (modules) {
      resolve(modules);
    }).catch(function (error) {
      reject(error);
    });
  });
};

// 异步请求组件的函数
module.exports = exports['default'];