'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

exports.getRouter = getRouter;
exports.getQueryParams = getQueryParams;
exports.navigation = navigation;
exports.getSearchParams = getSearchParams;
exports.getUrlParams = getUrlParams;
exports.getParam = getParam;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getRouter() {
  var loc = document.location;
  var hash = loc.hash.match(/^[#]{0,1}[\/]{0,1}([\s\S]+?)($|\?[\s\S]+)/)[1];
  return {
    'hash': hash,
    'host': loc.host,
    'hostname': loc.hostname,
    'href': loc.href,
    'origin': loc.origin,
    'pathname': loc.pathname,
    'port': loc.port,
    'protocol': loc.protocol
  };
}

function getQueryParams() {
  var loc = document.location;
  var resQuery = {};
  var queryStringExp = (loc.hash || '').match(/\?([\s\S]+)$/);
  if (queryStringExp) {
    var queryString = queryStringExp[1];
    var queryStrList = queryString.split('&');
    queryStrList.forEach(function (queryStr) {
      var que = queryStr.split('=');
      resQuery[que[0]] = decodeURIComponent(que[1]);
    });
    return resQuery;
  } else {
    return resQuery;
  }
}

function navigation(linkTo) {
  document.location.hash = linkTo;
}

function getSearchParams() {
  var loc = document.location;
  var resSearchParams = {};
  var searchString = loc.search.slice(1, loc.search.length);
  var searchStrList = searchString.split('&');
  searchStrList.forEach(function (searchStr) {
    var que = searchStr.split('=');
    resSearchParams[que[0]] = decodeURIComponent(que[1]);
  });
  return resSearchParams;
}

function getUrlParams() {
  var searchParams = getSearchParams();
  var qureyParams = getQueryParams();
  return (0, _extends3.default)({}, searchParams, qureyParams);
}

function getParam(key) {
  var query = getQueryParams();
  if (query[key]) return query[key];
  var search = getSearchParams();
  if (search[key]) return search[key];
}