'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends4 = require('babel-runtime/helpers/extends');

var _extends5 = _interopRequireDefault(_extends4);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _gridPageBuilder = require('@beisen/grid-page-builder');

var _gridPageBuilder2 = _interopRequireDefault(_gridPageBuilder);

var _utils = require('./utils');

var _utils2 = _interopRequireDefault(_utils);

var _pageTemplates = require('./components/page-templates');

var _pageTemplates2 = _interopRequireDefault(_pageTemplates);

var _elements = require('./components/elements');

var _elements2 = _interopRequireDefault(_elements);

var _properties = require('./components/properties');

var _properties2 = _interopRequireDefault(_properties);

var _validation = require('./components/properties/validate-wrapper/validation');

var _validation2 = _interopRequireDefault(_validation);

var _pageStateWrapper = require('./components/properties/page-state-wrapper');

var _formatters = require('./formatters');

var _contexts = require('./contexts');

var _metadataParser = require('./metadataParser');

var _metadataParser2 = _interopRequireDefault(_metadataParser);

var _filterParser = require('./helpers/filterParser');

var _filterParser2 = _interopRequireDefault(_filterParser);

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

require('react-transition-group');

var _uuid = require('uuid');

require('../src/static/css/index.css');

require('babel-polyfill');

require('react-addons-css-transition-group');

require('@beisen/nade-style/style.css');

require('@beisen/grid-page-builder/style.css');

require('../src/static/css/nature.design.min.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// import '../src/static/images/index.js'


var toPBuilderPageSource = _utils2.default.toPBuilderPageSource,
    toStandardPageSource = _utils2.default.toStandardPageSource,
    transferToPgbEditProps = _utils2.default.transferToPgbEditProps,
    transferToPgbCmps = _utils2.default.transferToPgbCmps;

var _default = (_temp = _class = function (_Component) {
  (0, _inherits3.default)(_default, _Component);

  function _default(props) {
    (0, _classCallCheck3.default)(this, _default);

    var _this = (0, _possibleConstructorReturn3.default)(this, (_default.__proto__ || (0, _getPrototypeOf2.default)(_default)).call(this, props));

    _initialiseProps.call(_this);

    var _props$elementCompone = props.elementComponents,
        elementComponents = _props$elementCompone === undefined ? [] : _props$elementCompone,
        _props$pageComponent = props.pageComponent,
        pageComponent = _props$pageComponent === undefined ? {} : _props$pageComponent,
        _props$pageSource = props.pageSource,
        standardPageSource = _props$pageSource === undefined ? {} : _props$pageSource;


    var pageSource = toPBuilderPageSource(standardPageSource);
    var tubSetting = _gridPageBuilder.TubState.create(pageSource);

    tubSetting.setSavedState(_this.props.saveBtnStatus);

    _this.state = {
      'cmpTubStateSetting': tubSetting || {},
      'pageComponent': pageComponent,
      'pageSource': pageSource,
      'standardPageSource': standardPageSource,
      'pageSource.ComponentList.classIds.mapping': {},
      'elementComponents': elementComponents,
      'saveBtnStatus': false,
      'cmpsMetadatas': {},
      'cmpsEditProps': {},
      'cmpsEvents': {},
      'hooks': {
        'instanceTimes': {},
        'validation': {},
        'onSubmit': {}
      }

      /* 提取组件元数据中的hooks和可以编辑属性 写入store */
    };var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = (0, _getIterator3.default)(_this.state.elementComponents), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var groupMetadata = _step.value;
        var _iteratorNormalCompletion2 = true;
        var _didIteratorError2 = false;
        var _iteratorError2 = undefined;

        try {
          for (var _iterator2 = (0, _getIterator3.default)(groupMetadata.components), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            var cmpMetadata = _step2.value;

            /* start */
            _this.attachEventsToSpecProperty(_this.cacheCmpsValidation(_this.cacheCmpsMetadata(_this.cacheCmpsEvents(_this.cacheCmpsHooksToStore(_this.cacheCmpsEditProps(cmpMetadata))))));
            /* end */
          }
        } catch (err) {
          _didIteratorError2 = true;
          _iteratorError2 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion2 && _iterator2.return) {
              _iterator2.return();
            }
          } finally {
            if (_didIteratorError2) {
              throw _iteratorError2;
            }
          }
        }
      }

      /* 页面组件的扁平配置 */
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    _this.attachEventsToSpecProperty(_this.cacheCmpsValidation(_this.cacheCmpsMetadata(_this.cacheCmpsEvents(_this.cacheCmpsHooksToStore(_this.cacheCmpsEditProps(_this.state.pageComponent))))));

    /*
    * 创建pageSource.ComponentList中组件id和classId的映射关系
    * pgb编辑态的时候，getEditProps API 未返回classId，找不到对应的props
    */
    _this.makePageSourceCmpClassIds();

    /*
    * 把state注入属性组件，提供使用
    */
    (0, _pageStateWrapper.installState)(_this.state);

    /*
    * 属性组件验证函数需要全部的state用来做验证
    * girdpagebuilder组件无法控制组件所有状态，通过外部包裹函数的手段添加state
    */
    (0, _validation.installValidates)(_this.props.validates);
    (0, _validation.injectValidatesScope)(_this.state);

    /* 注入scope进contexts */
    (0, _contexts.injectContextsScope)(_this.state);

    /*
    * 提供给外部注入
    */
    (0, _pageTemplates.installPageTemplates)(_this.props.pageTemplates);
    (0, _elements.installElements)(_this.props.elements);
    (0, _properties.installProperties)(_this.props.properties);
    (0, _formatters.installFormatters)(_this.props.formatters);
    (0, _contexts.installContexts)(_this.props.contexts);
    return _this;
  }

  /*
  * 创建pageSource.ComponentList中组件id和classId的映射关系
  * pgb编辑态的时候，getEditProps API 未返回classId，找不到对应的props
  */


  (0, _createClass3.default)(_default, [{
    key: 'makePageSourceCmpClassIds',
    value: function makePageSourceCmpClassIds() {
      var _state$pageSource$com = this.state.pageSource.componentList,
          componentList = _state$pageSource$com === undefined ? [] : _state$pageSource$com;
      var _iteratorNormalCompletion3 = true;
      var _didIteratorError3 = false;
      var _iteratorError3 = undefined;

      try {
        for (var _iterator3 = (0, _getIterator3.default)(componentList), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
          var _ref2 = _step3.value;
          var id = _ref2.id,
              classId = _ref2.classId;

          this.state['pageSource.ComponentList.classIds.mapping'][id] = classId;
        }
      } catch (err) {
        _didIteratorError3 = true;
        _iteratorError3 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion3 && _iterator3.return) {
            _iterator3.return();
          }
        } finally {
          if (_didIteratorError3) {
            throw _iteratorError3;
          }
        }
      }
    }
  }, {
    key: 'getInstanceTimes',
    value: function getInstanceTimes(id) {
      return this.state.hooks.instanceTimes[id];
    }
  }, {
    key: 'getValidation',
    value: function getValidation(id) {
      return this.state.hooks.validation[id];
    }
  }, {
    key: 'cacheCmpsMetadata',
    value: function cacheCmpsMetadata() {
      var cmpMetadata = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var id = cmpMetadata.id;

      this.state.cmpsMetadatas[id] = cmpMetadata;
      return cmpMetadata;
    }
  }, {
    key: 'cacheCmpsEvents',
    value: function cacheCmpsEvents() {
      var cmpMetadata = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var id = cmpMetadata.id,
          events = cmpMetadata.events;

      this.state.cmpsEvents[id] = events;
      return cmpMetadata;
    }
  }, {
    key: 'cacheCmpsValidation',
    value: function cacheCmpsValidation() {
      var cmpMetadata = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var cmpId = cmpMetadata['id'],
          _cmpMetadata$editProp = cmpMetadata.editProps,
          editProps = _cmpMetadata$editProp === undefined ? [] : _cmpMetadata$editProp;
      var _iteratorNormalCompletion4 = true;
      var _didIteratorError4 = false;
      var _iteratorError4 = undefined;

      try {
        for (var _iterator4 = (0, _getIterator3.default)(editProps), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
          var _ref4 = _step4.value;
          var propName = _ref4['name'],
              validation = _ref4.validation;

          if (!this.state.hooks.validation[cmpId]) this.state.hooks.validation[cmpId] = {};
          (0, _extends5.default)(this.state.hooks.validation[cmpId], (0, _defineProperty3.default)({}, propName, validation));
        }
      } catch (err) {
        _didIteratorError4 = true;
        _iteratorError4 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion4 && _iterator4.return) {
            _iterator4.return();
          }
        } finally {
          if (_didIteratorError4) {
            throw _iteratorError4;
          }
        }
      }

      return cmpMetadata;
    }

    /*
    * 把组件元数据中配置events添加到对应的事件编辑属性组件中
    * 在对应属性组件中，需要获取到当前属性的所属组件的events，和全局其他组件的events
    */

  }, {
    key: 'attachEventsToSpecProperty',
    value: function attachEventsToSpecProperty() {
      var cmpMetadata = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var specPropertyType = 'events-editor';
      var id = cmpMetadata.id,
          _cmpMetadata$events = cmpMetadata.events,
          events = _cmpMetadata$events === undefined ? {} : _cmpMetadata$events,
          _cmpMetadata$editProp2 = cmpMetadata.editProps,
          editProps = _cmpMetadata$editProp2 === undefined ? [] : _cmpMetadata$editProp2;
      var _iteratorNormalCompletion5 = true;
      var _didIteratorError5 = false;
      var _iteratorError5 = undefined;

      try {
        for (var _iterator5 = (0, _getIterator3.default)(editProps), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
          var prop = _step5.value;

          if (prop.type === specPropertyType) {
            var _prop$attributes = prop.attributes,
                attributes = _prop$attributes === undefined ? {} : _prop$attributes;

            var props = (0, _extends5.default)(attributes.props || {}, {
              targetClassId: id,
              targetEvents: events
            });
            (0, _extends5.default)(attributes, { props: props });
            (0, _extends5.default)(prop, { attributes: attributes });
          }
        }
      } catch (err) {
        _didIteratorError5 = true;
        _iteratorError5 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion5 && _iterator5.return) {
            _iterator5.return();
          }
        } finally {
          if (_didIteratorError5) {
            throw _iteratorError5;
          }
        }
      }

      return cmpMetadata;
    }

    /*
    * 注册的组件的元数据中接受固定的几个参数
    * 非标准的参数将会被用于自定义处理，比如目前正在使用的: onSubmit, instanceTimes, beforeSave
    */

  }, {
    key: 'cacheCmpsHooksToStore',
    value: function cacheCmpsHooksToStore() {
      var _this2 = this;

      var cmpMetadata = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var name = cmpMetadata.name,
          type = cmpMetadata.type,
          label = cmpMetadata.label,
          id = cmpMetadata.id,
          data = cmpMetadata.data,
          editProps = cmpMetadata.editProps,
          resthooks = (0, _objectWithoutProperties3.default)(cmpMetadata, ['name', 'type', 'label', 'id', 'data', 'editProps']);
      // 处理元数据中配置的hooks, 创建对应的扁平数据结构

      (0, _keys2.default)(resthooks).forEach(function (hookName) {
        if (!_this2.state.hooks[hookName]) _this2.state.hooks[hookName] = {};
        (0, _extends5.default)(_this2.state.hooks[hookName], (0, _defineProperty3.default)({}, id, resthooks[hookName]));
      });
      return cmpMetadata;
    }
  }, {
    key: 'cacheCmpsEditProps',
    value: function cacheCmpsEditProps() {
      var cmpMetadata = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var id = cmpMetadata.id,
          _cmpMetadata$editProp3 = cmpMetadata.editProps,
          editProps = _cmpMetadata$editProp3 === undefined ? {} : _cmpMetadata$editProp3;

      this.state.cmpsEditProps[id] = editProps;
      return cmpMetadata;
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.state.cmpTubStateSetting.setSavedState(false);
    }

    /* 情况特殊，直接通过callback返回数据源，不走单项数据流 */
    /* pageBuilder 对每个组件props缓存，只会调用一次 */

  }, {
    key: 'genId',
    value: function genId() {
      return (0, _uuid.v1)();
    }

    /*
    * 验证组件中的可编辑属性，通过配置的validation
    */

  }, {
    key: 'validateCmp',
    value: function validateCmp(editableData) {
      var validateCmpConfig = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var cmpId = arguments[2];

      for (var edKey in editableData) {
        if (validateCmpConfig[edKey]) {
          var propValidation = validateCmpConfig[edKey];
          var _iteratorNormalCompletion6 = true;
          var _didIteratorError6 = false;
          var _iteratorError6 = undefined;

          try {
            for (var _iterator6 = (0, _getIterator3.default)(propValidation), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true) {
              var _ref6 = _step6.value;
              var type = _ref6.type,
                  message = _ref6.message,
                  params = _ref6.params;

              var data = editableData[edKey];
              if (_validation2.default[type]) {
                var valiRes = _validation2.default[type](data, params, { filterParser: _filterParser2.default, filterObjValuesParser: _filterParser.parseObjValues });
                if (!valiRes) {
                  return { id: cmpId };
                }
              } else {
                throw new Error('\u672A\u627E\u5230\u6307\u5B9A\u9A8C\u8BC1\u51FD\u6570: ' + type);
              }
            }
          } catch (err) {
            _didIteratorError6 = true;
            _iteratorError6 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion6 && _iterator6.return) {
                _iterator6.return();
              }
            } finally {
              if (_didIteratorError6) {
                throw _iteratorError6;
              }
            }
          }
        }
      }
    }
  }, {
    key: 'validateOnSave',
    value: function validateOnSave(tubState) {
      var _tubState$componentLi = tubState.componentList,
          componentList = _tubState$componentLi === undefined ? [] : _tubState$componentLi,
          _tubState$pageSetting = tubState.pageSettings,
          pageSettings = _tubState$pageSetting === undefined ? {} : _tubState$pageSetting;

      /* 组件的验证 */

      var _iteratorNormalCompletion7 = true;
      var _didIteratorError7 = false;
      var _iteratorError7 = undefined;

      try {
        for (var _iterator7 = (0, _getIterator3.default)(componentList), _step7; !(_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done); _iteratorNormalCompletion7 = true) {
          var _ref8 = _step7.value;
          var editableData = _ref8.editableData,
              name = _ref8.name,
              id = _ref8.id,
              classId = _ref8.classId;

          /*
          * classId: 和左侧拖拽组件对应的 id 属性
          * pgb左侧的组件都会有一个id
          * 组件被拖拽到控制台，在控制台中组件会生成一个新的id（实例id），classId为左侧属性组件的id
          */
          var res = this.validateCmp(editableData, this.getValidation(classId), id);
          if (res) return res;
        }

        /* 页面组件的验证 */
      } catch (err) {
        _didIteratorError7 = true;
        _iteratorError7 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion7 && _iterator7.return) {
            _iterator7.return();
          }
        } finally {
          if (_didIteratorError7) {
            throw _iteratorError7;
          }
        }
      }

      return this.validateCmp(pageSettings.editableData, this.getValidation(this.state.pageComponent.id), null);
    }
  }, {
    key: 'getPageTemplate',
    value: function getPageTemplate() {
      var PageTemplate = _pageTemplates2.default[this.state.pageComponent.type];
      if (!PageTemplate) {
        throw new Error('\u672A\u627E\u5230\u9875\u9762\u7EC4\u4EF6: ' + this.state.pageComponent.type);
      }

      /* 向布局模板组件注入 属性配置 */
      var stardandEditProps = this.state.pageComponent.editProps;
      var pbgEditProps = transferToPgbEditProps(stardandEditProps);
      PageTemplate.editProps = pbgEditProps;
      return PageTemplate;
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.saveBtnStatus !== this.state.saveBtnStatus) {
        this.state.cmpTubStateSetting.setSavedState(nextProps.saveBtnStatus);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      // previewUrl = '#/gview' 
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(_gridPageBuilder2.default, {
          tubState: this.state.cmpTubStateSetting,
          template: this.getPageTemplate(),
          components: _elements2.default,
          defaultProps: { 'component': [] },
          propsComponents: _properties2.default,
          availableComponents: transferToPgbCmps(this.state.elementComponents),
          onChange: this.handleChange,
          onSave: this.handleSave,
          genUID: this.genId,
          onBeforeCreateComponent: this.onBeforeCreateComponent,
          onBeforeRemoveComponent: this.onBeforeRemoveComponent,
          onMessage: this.handleMessage,
          getEditProps: this.getEditProps
        })
      );
    }
  }]);
  return _default;
}(_react.Component), _initialiseProps = function _initialiseProps() {
  var _this3 = this;

  this.getEditProps = function (type, id) {
    return new _promise2.default(function (resolve, reject) {
      var stardandEditProps = _this3.state.cmpsEditProps[id];
      /*
      * 创建pageSource.ComponentList中组件id和classId的映射关系
      * pgb编辑态的时候，getEditProps API 未返回classId，找不到对应的props
      */
      if (!stardandEditProps) {
        var mappedPageSourceClassid = _this3.state['pageSource.ComponentList.classIds.mapping'][id];
        stardandEditProps = _this3.state.cmpsEditProps[mappedPageSourceClassid];
      }
      var pgbEditProps = transferToPgbEditProps(stardandEditProps);
      resolve(pgbEditProps);
    });
  };

  this.handleChange = function (cmpTubStateSetting) {
    var standardPageSource = toStandardPageSource(cmpTubStateSetting.toJS(), _this3.state);
    _this3.setState({ cmpTubStateSetting: cmpTubStateSetting, standardPageSource: standardPageSource });
    _this3.props.onChange(standardPageSource);
  };

  this.handleSave = function (tubStateSource) {
    var activeCmp = _this3.validateOnSave(tubStateSource);
    if (activeCmp) {
      _this3.setState({
        'cmpTubStateSetting': _this3.state.cmpTubStateSetting.setSelect(activeCmp.id)
      });
    } else {
      var standardPageSource = toStandardPageSource(tubStateSource, _this3.state);
      var metadata = (0, _metadataParser2.default)(standardPageSource, _this3.state);
      _this3.props.savePage(metadata);
    }
  };

  this.onBeforeCreateComponent = function (_ref9, pageData) {
    var name = _ref9.name,
        type = _ref9.type,
        id = _ref9.id;

    /* 在 组件和实例化次数 mapping 关系中，找到当前组件的初始化限制 */
    var instanceTimes = _this3.getInstanceTimes(id);
    /* 获取cmp在视图中已经被实例化的次数 */
    var instanceCmpId = pageData.componentList.filter(function (item) {
      return item.cType == name;
    }).length;
    /* 未曾被实例化过 */
    if (!instanceCmpId) {
      return true;
    } else {
      var limit = function () {
        var pageType = _this3.state.pageComponent.type;
        for (var insKey in instanceTimes) {
          if (insKey.toLowerCase() === pageType.toLowerCase()) {
            return instanceTimes[insKey];
          }
        }
        /* 未配置 instanceTimes，不做限制 */
        return 9999;
      }();
      return instanceCmpId < limit;
    }
  };

  this.onBeforeRemoveComponent = function (_ref10) {
    // this.instance[cType] = this.instance[cType] - 1

    var cType = _ref10.cType;
  };
}, _temp);

exports.default = _default;
module.exports = exports['default'];