'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (tubState) {
  var cmpsTree = [];

  var cmpList = tubState.componentList.map(function (item) {
    return (0, _extends3.default)({}, item, { children: [] });
  });

  var sectionIds = tubState.sectionList.map(function (item) {
    return item.id;
  });

  var map = {},
      cmp = void 0;
  for (var i = 0; i < cmpList.length; i++) {
    cmp = cmpList[i];
    map[cmp.id] = i;
    // 非根节点组件 
    if (sectionIds.indexOf(cmp['parentId']) < 0) {
      cmpList[map[cmp['parentId']]].children.push(cmp);
    } else {
      /* 根节点组件 */
      cmpsTree.push(cmp);
    }
  }

  //依据sectionIds 重排序
  cmpsTree = sectionIds.map(function (item) {
    var index = cmpsTree.findIndex(function (component) {
      return component['parentId'] == item;
    });
    return cmpsTree[index];
  });

  return cmpsTree;
};

module.exports = exports['default'];