'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

exports.default = parse;

var _index = require('./layoutParser/index');

var _onSubmit = require('./onSubmit');

var _onSubmit2 = _interopRequireDefault(_onSubmit);

var _createCmpsTree = require('./createCmpsTree');

var _createCmpsTree2 = _interopRequireDefault(_createCmpsTree);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function parse(tubState, state) {
  return (0, _onSubmit2.default)(tubState, state, function (newTubState) {
    var cmpsTree = (0, _createCmpsTree2.default)(newTubState);

    /* pageBuilder 组件转化为 upaas组件 1对多 的关系 */
    var upaasCmps = function _self(cmpsTree) {
      var resUpaasCmps = [];
      var children = [];

      for (var i = 0; i < cmpsTree.length; i++) {
        var pgCmp = cmpsTree[i];

        /* 递归开始 */
        if (pgCmp.children && pgCmp.children.length) {
          pgCmp.children = _self(pgCmp.children);
        }

        /* 生成 upaas 组件元数据 */
        var upaasCmpData = (0, _index.upaasCmpTransfer)(pgCmp, state);

        resUpaasCmps.push(upaasCmpData);
      }

      return resUpaasCmps;
    }(cmpsTree);

    var pageSettingUpaasCmpData = (0, _index.upaasCmpTransfer)(newTubState.pageSettings, state);

    var pageLayout = (0, _extends3.default)({}, pageSettingUpaasCmpData, { 'children': upaasCmps });

    return { 'layout': pageLayout, 'page': newTubState };
  });
}
module.exports = exports['default'];