'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var genUpaasCmpProps = function genUpaasCmpProps() {
  var pBuilderCmp = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var props = {};

  var _pBuilderCmp$editable = pBuilderCmp.editableData,
      editableData = _pBuilderCmp$editable === undefined ? {} : _pBuilderCmp$editable;

  for (var eKey in editableData) {
    var eVal = editableData[eKey];
    props[eKey] = eVal;
  }

  return props;
};

var upaasCmpTransfer = exports.upaasCmpTransfer = function upaasCmpTransfer() {
  var pBuilderCmp = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var state = arguments[1];

  /* pageBuilder 生成的 key 充当 upaas元数据的 slot */
  var slot = pBuilderCmp['componentHolderKey'],
      classId = pBuilderCmp.classId;


  var props = genUpaasCmpProps(pBuilderCmp);

  /* 不定结构都需要转成字符串 */
  var _ref = {},
      _ref$events = _ref.events,
      events = _ref$events === undefined ? props.events || {} : _ref$events;

  /*
  * 事件放在props的平级，删除props中的events
  */

  delete props.events;

  var cmpsMetadatas = state.cmpsMetadatas;

  var name = cmpsMetadatas[classId].name;

  var id = pBuilderCmp.id,
      type = pBuilderCmp.type,
      _pBuilderCmp$children = pBuilderCmp.children,
      children = _pBuilderCmp$children === undefined ? [] : _pBuilderCmp$children;


  var upaasCmpData = {
    id: id,
    name: name,
    type: type,
    'attributes': {
      props: props,
      slot: slot,
      events: events
    },
    children: children
    // engine,
    // container
  };

  return upaasCmpData;
};