'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _ValidateError = require('./ValidateError');

var _ValidateError2 = _interopRequireDefault(_ValidateError);

var _tabContainerDynamic = require('./tabContainerDynamic');

var _tabContainerDynamic2 = _interopRequireDefault(_tabContainerDynamic);

var _makeDataSource = require('./makeDataSource');

var _makeDataSource2 = _interopRequireDefault(_makeDataSource);

var _validateRequiredCmps = require('./validateRequiredCmps');

var _validateRequiredCmps2 = _interopRequireDefault(_validateRequiredCmps);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var hooks = {
  tabContainerDynamic: _tabContainerDynamic2.default,
  makeDataSource: _makeDataSource2.default,
  validateRequiredCmps: _validateRequiredCmps2.default
};

var executeHook = function executeHook(tubState) {
  var cmp = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var configs = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = (0, _getIterator3.default)(configs), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var _ref2 = _step.value;
      var _ref2$type = _ref2.type,
          type = _ref2$type === undefined ? '' : _ref2$type,
          _ref2$params = _ref2.params,
          params = _ref2$params === undefined ? {} : _ref2$params;

      if (!hooks[type]) {
        throw new Error('\u672A\u627E\u5230\u6307\u5B9A onSubmit \u51FD\u6570: ' + type);
      }
      tubState = hooks[type](tubState, cmp, params);
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return tubState;
};

var onSubmit = function onSubmit(tubState, state) {
  var cmpConfigs = state.hooks.onSubmit;
  var pageSettingConfigs = state.hooks.onSubmit[state.pageComponent.id];

  /* pageSetting */
  tubState = executeHook(tubState, tubState.pageSettings, pageSettingConfigs);

  /* cmps */
  var _tubState = tubState,
      _tubState$componentLi = _tubState.componentList,
      componentList = _tubState$componentLi === undefined ? [] : _tubState$componentLi;

  componentList.map(function (_ref3) {
    var id = _ref3.id,
        name = _ref3.name;
    return { name: name, id: id };
  }).forEach(function (_ref4) {
    var cmpName = _ref4['name'],
        cmpId = _ref4['id'];
    var _cmpConfigs$cmpId = cmpConfigs[cmpId],
        configs = _cmpConfigs$cmpId === undefined ? [] : _cmpConfigs$cmpId;
    var _tubState2 = tubState,
        _tubState2$componentL = _tubState2['componentList'],
        cmps = _tubState2$componentL === undefined ? [] : _tubState2$componentL;

    var cmp = cmps.filter(function (_ref5) {
      var id = _ref5.id;
      return id == cmpId;
    })[0];
    tubState = executeHook(tubState, cmp, configs);
  });

  return tubState;
};

exports.default = function (tubState, state, next) {
  try {
    var newTubState = onSubmit(tubState, state);
    return next(newTubState);
  } catch (e) {
    if (e instanceof _ValidateError2.default) {
      alert(e.message);
      return false;
    } else {
      throw e;
    }
  }
};

module.exports = exports['default'];