'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _filterParser = require('../../helpers/filterParser');

var _filterParser2 = _interopRequireDefault(_filterParser);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getValueFromPath = function getValueFromPath(value) {
  var paths = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

  if (!value) return null;
  var targetValue = value;
  paths.split('|').forEach(function (pathItemKey) {
    targetValue = targetValue[pathItemKey];
  });
  return targetValue;
};

exports.default = function (tubState, cmpMetaData, params) {
  var dataSource = [];

  var dataSourceGetter = params.dataSourceGetter;

  if (!dataSourceGetter) dataSourceGetter = params;

  var _cmpMetaData$editable = cmpMetaData.editableData,
      editableData = _cmpMetaData$editable === undefined ? {} : _cmpMetaData$editable;
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {

    for (var _iterator = (0, _getIterator3.default)(dataSourceGetter), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var _ref2 = _step.value;
      var _ref2$key = _ref2.key,
          key = _ref2$key === undefined ? '' : _ref2$key,
          _ref2$value = _ref2.value,
          value = _ref2$value === undefined ? '' : _ref2$value;

      value = (0, _filterParser2.default)(value, (0, _extends3.default)({}, editableData));
      dataSource.push({ 'key': key, 'value': value });
    }

    /* 在组件元数据中追加 dataSource */
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  var matched = false;
  var _tubState$componentLi = tubState.componentList,
      componentList = _tubState$componentLi === undefined ? [] : _tubState$componentLi,
      pageSettings = tubState.pageSettings;
  var _iteratorNormalCompletion2 = true;
  var _didIteratorError2 = false;
  var _iteratorError2 = undefined;

  try {
    for (var _iterator2 = (0, _getIterator3.default)(componentList), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
      var tubCmp = _step2.value;
      var id = tubCmp.id;

      if (id == cmpMetaData.id) {
        tubCmp['dataSource'] = dataSource;
        matched = true;
      }
    }
  } catch (err) {
    _didIteratorError2 = true;
    _iteratorError2 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion2 && _iterator2.return) {
        _iterator2.return();
      }
    } finally {
      if (_didIteratorError2) {
        throw _iteratorError2;
      }
    }
  }

  tubState.componentList = componentList;

  if (!matched && pageSettings.id == cmpMetaData.id) {
    tubState.pageSettings['dataSource'] = dataSource;
  }

  return tubState;
};

module.exports = exports['default'];