'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isExternalTabCmp = function isExternalTabCmp(tubState, tabCmpMetaData) {
  var parentId = tabCmpMetaData.parentId;
  var _tubState$componentLi = tubState.componentList,
      componentList = _tubState$componentLi === undefined ? [] : _tubState$componentLi,
      _tubState$sectionList = tubState.sectionList,
      sectionList = _tubState$sectionList === undefined ? [] : _tubState$sectionList;

  var sections = sectionList.map(function (_ref) {
    var id = _ref.id;
    return id;
  });
  return sections.includes(parentId);
};

var dynamicTotalCmpChildren = function _self(tubState, cmpMetaData) {
  var _tubState = tubState,
      _tubState$componentLi2 = _tubState.componentList,
      componentList = _tubState$componentLi2 === undefined ? [] : _tubState$componentLi2;
  var _cmpMetaData$editable = cmpMetaData.editableData,
      editableData = _cmpMetaData$editable === undefined ? {} : _cmpMetaData$editable,
      cmpId = cmpMetaData['id'];
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {

    for (var _iterator = (0, _getIterator3.default)(componentList), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var cmp = _step.value;
      var parentId = cmp.parentId,
          name = cmp.name;


      if (parentId == cmpId) {
        cmp.isDynamicComponent = true;
        /* 如果子节点是一个Tab组件，则递归 */
        if (name == 'upaas-tab-container') {
          tubState = _self(tubState, cmp);
        }
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return tubState;
};

var dynamicTotalUnActiveCmpChildren = function _self(tubState, cmpMetaData) {
  var _tubState2 = tubState,
      _tubState2$componentL = _tubState2.componentList,
      componentList = _tubState2$componentL === undefined ? [] : _tubState2$componentL;
  var _cmpMetaData$editable2 = cmpMetaData.editableData,
      editableData = _cmpMetaData$editable2 === undefined ? {} : _cmpMetaData$editable2,
      cmpId = cmpMetaData['id'];
  var _editableData$tabConf = editableData['tabConfig'].defaultTab,
      defaultTab = _editableData$tabConf === undefined ? '' : _editableData$tabConf;
  var _iteratorNormalCompletion2 = true;
  var _didIteratorError2 = false;
  var _iteratorError2 = undefined;

  try {

    for (var _iterator2 = (0, _getIterator3.default)(componentList), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
      var cmp = _step2.value;
      var parentId = cmp.parentId,
          name = cmp.name,
          componentHolderKey = cmp.componentHolderKey;

      if (parentId == cmpId) {

        if (componentHolderKey != defaultTab) {
          cmp.isDynamicComponent = true;

          /* 如果子节点是一个Tab组件，则递归 */
          if (name == 'upaas-tab-container') {
            tubState = _self(tubState, cmp);
          }
        }
      }
    }
  } catch (err) {
    _didIteratorError2 = true;
    _iteratorError2 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion2 && _iterator2.return) {
        _iterator2.return();
      }
    } finally {
      if (_didIteratorError2) {
        throw _iteratorError2;
      }
    }
  }

  return tubState;
};

exports.default = function (tubState, tabCmpMetaData) {
  if (!isExternalTabCmp(tubState, tabCmpMetaData)) {
    return tubState;
  }

  var _tubState3 = tubState,
      _tubState3$componentL = _tubState3.componentList,
      componentList = _tubState3$componentL === undefined ? [] : _tubState3$componentL;
  var _tabCmpMetaData$edita = tabCmpMetaData.editableData,
      editableData = _tabCmpMetaData$edita === undefined ? {} : _tabCmpMetaData$edita,
      tabContainerId = tabCmpMetaData['id'];
  var _editableData$tabConf2 = editableData['tabConfig'],
      _editableData$tabConf3 = _editableData$tabConf2.defaultTab,
      defaultTab = _editableData$tabConf3 === undefined ? '' : _editableData$tabConf3,
      isActiveFirstItem = _editableData$tabConf2.isActiveFirstItem,
      _editableData$tabConf4 = _editableData$tabConf2.tabItemList,
      tabItemList = _editableData$tabConf4 === undefined ? [] : _editableData$tabConf4;


  if (isActiveFirstItem) {
    defaultTab = (tabItemList[0] || {}).value;
  }

  var _iteratorNormalCompletion3 = true;
  var _didIteratorError3 = false;
  var _iteratorError3 = undefined;

  try {
    for (var _iterator3 = (0, _getIterator3.default)(componentList), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
      var cmpMetaData = _step3.value;
      var parentId = cmpMetaData.parentId,
          componentHolderKey = cmpMetaData.componentHolderKey,
          name = cmpMetaData.name;

      if (parentId == tabContainerId) {

        if (componentHolderKey == defaultTab) {

          if (name == 'upaas-tab-container') {
            tubState = dynamicTotalUnActiveCmpChildren(tubState, cmpMetaData);
          }
        } else {
          cmpMetaData.isDynamicComponent = true;
          if (name == 'upaas-tab-container') {
            tubState = dynamicTotalCmpChildren(tubState, cmpMetaData);
          }
        }
      }
    }
  } catch (err) {
    _didIteratorError3 = true;
    _iteratorError3 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion3 && _iterator3.return) {
        _iterator3.return();
      }
    } finally {
      if (_didIteratorError3) {
        throw _iteratorError3;
      }
    }
  }

  return tubState;
};

module.exports = exports['default'];