'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* 初始化pgb转换数据结构的函数 */
exports.default = function (standardPageData) {
  if (!standardPageData) return {};
  if (!standardPageData.componentList) return {};

  var _standardPageData$com = standardPageData.componentList,
      componentList = _standardPageData$com === undefined ? [] : _standardPageData$com,
      pageSettings = standardPageData.pageSettings,
      restData = (0, _objectWithoutProperties3.default)(standardPageData, ['componentList', 'pageSettings']);

  componentList = componentList.map(function (cmp) {
    var name = cmp.name,
        type = cmp.type,
        restData = (0, _objectWithoutProperties3.default)(cmp, ['name', 'type']);

    return (0, _extends3.default)({ 'cType': type }, restData);
  });

  /*
  * 去掉，pgb不接受的其他属性
  */
  var _pageSettings = pageSettings,
      id = _pageSettings.id,
      classId = _pageSettings.classId,
      type = _pageSettings.type,
      name = _pageSettings.name,
      cType = _pageSettings.cType,
      restSettings = (0, _objectWithoutProperties3.default)(_pageSettings, ['id', 'classId', 'type', 'name', 'cType']);


  pageSettings = restSettings;

  return (0, _extends3.default)({
    pageSettings: pageSettings, componentList: componentList }, restData);
};

module.exports = exports['default'];