'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
* 格式化pgb生成的配置
* 1. 把componentList中组件的cType替换成type
* 2. 给pageSetting添加 id, classId, type, name 属性，和 component 元数据统一
*/
exports.default = function (tubState, state) {
  var componentList = [];
  /* 生成 cmpId - pgId one vs more 关系 */
  tubState.componentList.forEach(function (cmp) {
    var standardCmpData = toStandardCmpData(cmp);
    var editableData = cmp.editableData,
        classId = cmp.classId;

    componentList.push(standardCmpData);
  });

  tubState['componentList'] = componentList;

  /* 添加页面组件的必要字段 */
  var _state$pageComponent = state.pageComponent,
      name = _state$pageComponent.name,
      id = _state$pageComponent.id,
      type = _state$pageComponent.type,
      editableData = _state$pageComponent.editableData;


  tubState.pageSettings['id'] = id; /* 实例化id，页面类型的组件，使用cmp_id做为实例化id */
  tubState.pageSettings['classId'] = id; /* 实例化组件 和 Cloud组件的对应关系 */
  tubState.pageSettings['type'] = type; /* 组件类型 */
  tubState.pageSettings['name'] = name; /* upaas组件的类型 */

  return tubState;
};

var toStandardCmpData = function toStandardCmpData(component) {
  var cType = component.cType,
      restData = (0, _objectWithoutProperties3.default)(component, ['cType']);

  return (0, _extends3.default)({ 'type': cType }, restData);
};
module.exports = exports['default'];