import React, {Component, PropTypes} from 'react'
import {render} from 'react-dom'
import ToolTip from "@beisen/tool-tip"

export default class CheckboxItem extends Component{

  clickItem = (e) => {
    const {handleClick, value, text, item} = this.props;
    handleClick(value,text,e,item);
  }
  render () {
    const { bsStyle=true, handleClick, value, text, handleHover, handleMouseOut, cmp_id } = this.props
    const { helpMsg } = this.props

    return (
      <div 
        style={{ 'position': 'relative' }}
        className={(bsStyle?'cklist-checkbox cklist-optional':'cklist-checkbox cklist-notOptional')+' checkbox-horizontal '} >

        <label className={bsStyle?this.props.isChecked:"table-item-check table-item-check-back"} 
                onClick={this.clickItem} 
                onMouseOver={handleHover} 
                onMouseOut={handleMouseOut}
                data-logtype = 'click'
                data-loglabel = 'CheckBoxList-Icon'
                data-logcmpid = {cmp_id}
        ></label>

        <label className="check-title" 
                onClick={handleClick.bind(this,value,this.props)}
                data-logtype = 'click'
                data-loglabel = 'CheckBoxList-Text'
                data-logcmpid = {cmp_id}
        >{text}</label>

        {
          helpMsg ? <span className="form-item__help">
              <ToolTip title={ helpMsg }>
                <span className="u-icon sys-icon-cus-bangzhu" style={{ 'cursor': 'pointer' }}></span>
              </ToolTip>
            </span> : null
        }
      </div>
    )
  }
}
