
import CheckboxList from '@beisen/checkbox-list'
import CheckboxItem from './checkbox-item'
import ToolTip from "@beisen/tool-tip"

export default class extends CheckboxList {

  render() {
    const checkboxItems = this.state.checkboxItems;
    const {name, hidden, disabled, required, errorStatus, helpMsg, sideTip, hiddenTip, lablePos, lableTxt} = this.props;

    let errorMsg = "请填写正确信息",
      errorContent, checkboxList;

    if (this.props.errorStatus) {
      errorMsg = this.props.errorMsg.length > 0 ? this.props.errorMsg : errorMsg;
      errorContent = <span className="form-item__explain">{errorMsg}</span>
    }

    let lableStyle; 
    if (lablePos) {
      lableStyle = lableTxt ? {'float':'left','textAlign':'left'} : {'float':'left','textAlign':'right'};
    }else{
      lableStyle = {};
    }

    if (hidden) {
      return <div className = "field checkboxlist"> </div>
    } else {
      return (
        <div className={"form-item checkboxlist "+(helpMsg?"form-item__help":"")}>
            <div className = "form-item__title" title = {name} style={lableStyle}>
              {required ? <a className="form-item__required"><i className="u-icon pc-sys-cus-bitian-svg"></i></a>:""}
              <ToolTip title={name} side={sideTip} hidden={hiddenTip}>  
                <label htmlFor="" className="form-item__text">{name}</label>
              </ToolTip>
              {helpMsg ? <ToolTip title={helpMsg} side={sideTip} hidden={hiddenTip}>
                  <i className="u-icon sys-icon-cus-bangzhu"></i>
              </ToolTip> : ''}
            </div >
            <div className = {"form-item__control "+(errorStatus?"form-item__control_has-error":"")} >
              <div style={{"marginLeft":"5px"}}>
                {
                  checkboxItems.map((item, index) => {
                    let isChecked;
                    if (disabled) {
                      isChecked = item.isChecked ? "table-item-check table-item-check-go pc-sys-Checkbox-active-svg":'table-item-check table-item-check-back pc-sys-Checkbox-disabled-svg';
                    } else {
                      isChecked = item.isChecked ? "table-item-check table-item-check-go pc-sys-Checkbox-active-svg" : "table-item-check table-item-check-back pc-sys-Checkbox-nomal-svg";
                    }
                    return ( <CheckboxItem key={index} item = {item} isChecked={isChecked}
                      text = {item.text}
                      bsStyle = {item.bsStyle}
                      value = {item.value}
                      helpMsg = {item.helpMsg}
                      handleClick = {this.handleClick}
                      handleHover = {this.handleHover}
                      handleMouseOut = {this.handleMouseOut}/>
                    )
                  })
                }
              </div>
              {errorContent}
          </div>
        </div>
      )
    }
  }
}
