
import React, { Component } from 'react'
import CheckboxList from './based-checkbox-list'
import '../../../../src/components/basis/checkbox-list/index.css'

export default class extends Component {
  constructor (props) {
    super(props)
  }

  onClick = (e, data) => {
    data = data.map(({ value, text, helpMsg }) => {
      return {
        value,
        'label': text,
        'help': helpMsg,
      }
    })
    this.props.onChange(data)
  }

  render () {
    let { items=[], checked=[] } = this.props

    let checkboxItems = items.map(({ label, value, help }) => {
      return {
        'value': value,
        'bsStyle': true,
        'isChecked': checked.includes(value) ? true : false,
        'text': label,
        'helpMsg': help,
      }
    })

    return <div className='pg-props-common-checkbox-list'>
      <CheckboxList checkboxItems={ checkboxItems } onClick={ this.onClick }
        hasRender={ true } />
    </div>
  }
}
