import React, { Component } from 'react'
import GetJsonEditor from './get-json-editor'
import AceJsonEditor from './ace-json-editor'
import filterParser from '../../../helpers/filterParser'

import '../../../../src/components/basis/json-editor/index.css'

@GetJsonEditor
export default class extends Component {

  constructor (props) {
    super(props)
    this.state = {}
    this.aceJsonEditorId = 'pg-ace-core-json-editror'
    this.editor = undefined
  }

  componentDidMount () {
    this.initAceJsonEditor()
  }

  componentWillUnmount () {
    this.destoryAceJsonEditor()
  }

  componentWillReceiveProps (nextProps) {
    /* 赋值 */
    // if (nextProps.value !== this.props.value) {
    let value = JSON.stringify(nextProps.value)
    this.editor.setValue(value)
    // }
  }

  destoryAceJsonEditor () {
    this.editor.destroy()
  }

  aceJsonEditorOnChange (e) {
    let value = this.editor.getValue()
    try {
      value = filterParser("{{ targetValue | convert 'JSON' }}", { targetValue: value })
    } catch (e) {}
    this.props.onChange(value)
  }

  initAceJsonEditor () {
    this.editor = AceJsonEditor.ace.edit(this.aceJsonEditorId)
    this.editor.session.setMode("ace/mode/json")

    /* 内容发生变化 */
    this.editor.on("change", (e) => {
      this.aceJsonEditorOnChange(e)
    })

    let { value = {} } = this.props
    value = JSON.stringify(value)
    this.editor.setValue(value, 1) // 1: move cursor to the end
  }

  render () {
    return <div className="pg-ace-json-editror-container">
      <pre id={ `${ this.aceJsonEditorId }` } className="pg-ace-json-editror"></pre>
    </div>
  }
}
