import React, { Component } from 'react'
import JsonEditor from '../json-editor'
import CommonPop from "@beisen/common-pop"

import '../../../../src/components/basis/json-pop-editor/index.css'

export default class extends Component {
  constructor (props) {
    super(props)
    this.state = {
      'showEditor': false
    }
    this.jsonEditorValue
  }

  onEditorChangeHandler = (value) => {
    this.jsonEditorValue = value
  }

  popViewSave = () => {
    this.props.onChange(this.jsonEditorValue)
    this.setState({ 'showEditor': false })
  }

  popViewClose = () => {
    this.setState({ 'showEditor': false })
  }

  onEditClickHandler = () => {
    this.setState({ 'showEditor': true })
  }

  render () {
    let { value = {} } = this.props
    let { showEditor } = this.state

    let jsonEditor = <JsonEditor value={ value } onChange={ this.onEditorChangeHandler } />

    return <div className='pg-common-cmp-json-editor'>
      
      <div className="pg-common-cmp-json-readonly-container">
        <pre className="pg-common-cmp-json-readonly">{ JSON.stringify(value) }</pre>
      </div>
      
      <div className="pg-common-cmp-json-editor-edit-container">
        <span className="ui-icon sys-icon-IM-bianji pg-common-cmp-json-editor-edit" onClick={ this.onEditClickHandler }></span>
      </div>
      
      {
        showEditor ? <CommonPop
          title={ '编辑' }
          dataType={ 'component' }
          hasFooter={ true }
          hasHeader={ true }
          showMask={ true }
          data={ jsonEditor }
          submitPop={ this.popViewSave }
          closePop={ this.popViewClose } /> : null
      }
    </div>
  }
}
