import React, { Component } from 'react'
import { connect } from 'react-redux'

import '../../../../../src/components/basis/page-creator/create-page-form/index.scss'

export default class CreatePage extends Component {

  constructor(props) {
    super(props)
    this.state = {
      'data': this.props.data
    }
  }

  onInputChange (e, key, limition) {
    let data = this.state.data
    data[key] = e.target.value.substring(0,limition);
    this.setState({ 'data': data })
    this.props.onValuesChange(data)
  }

  render() {
    let { name, code, describe, pageType, metaObjName } = this.state.data

    return <div className="pg-create-form-container">
        <ul className="pg-create-form">
          <li>
            <div className="form-item">
              <div className="form-item__title">
                <a className="form-item__required">
                  <i className="u-icon pc-sys-cus-bitian-svg"></i>
                </a>
                <label for="" className="form-item__text">名称</label>
              </div>

              <div className={
                  this.props.nameError ? 
                  'form-item__control form-item__control_is-active form-item__control_has-info form-item__control_has-error' :
                  'form-item__control'}>
                <input type="text" className="u-input" placeholder="页面名称" value={name}
                  onChange={(e) => this.onInputChange(e, 'name',50) } />
                <span className="form-item__bottom-line"></span>
                {
                  this.props.nameError
                    ? 
                    <span className="form-item__explain">名称不可为空(最大长度为50)</span>
                    : 
                    <span className="form-item__right-icon">
                      
                    </span>
                }
              </div>

            </div>
          </li>
          <li>
            <div className="form-item">
                <div className="form-item__title">
                  <a className="form-item__required">
                    <i className="u-icon pc-sys-cus-bitian-svg"></i>
                  </a>
                  <label for="" className="form-item__text">编码</label>
                </div>
                <div className={
                  (this.props.codeError || this.props.codeRepeat || this.props.codeCharacterError) ? 
                  'form-item__control form-item__control_is-active form-item__control_has-info form-item__control_has-error' :
                  'form-item__control'}>
                  <input type="text" className="u-input" placeholder="页面编码" value={code}
                    onChange={(e) => this.onInputChange(e, 'code',50) }
                  />
                  <span className="form-item__bottom-line"></span>
                  {
                    (this.props.codeError || this.props.codeRepeat || this.props.codeCharacterError)
                      ? 
                      <span className="form-item__explain">{
                        this.props.codeRepeat ? '编码已存在(不允许是系统关键词)' : (
                          this.props.codeCharacterError ? '编码只允许输入数字和字母' : '编码不可为空(最大长度为50)'
                        )
                      }</span>
                      : 
                      <span className="form-item__right-icon">
                        
                      </span>
                  }
                </div>
              </div>
          </li>
          {
            metaObjName ? <li>
              <div className="form-item">
                <div className="form-item__title">
                  <label for="" className="form-item__text">对象</label>
                </div>
                <div className="form-item__control form-item__control_is-readonly">
                  <input type="text" className="u-input" value={metaObjName} readOnly />
                  <span className="form-item__bottom-line"></span>
                  <span className="form-item__right-icon">
                    <i className="u-icon pc-sys-bukebianji-nomal-svg"></i>
                  </span>
                </div>
              </div>
            </li> : null
          }
          
          <li>
            <div className="form-item">
              <div className="form-item__title">
                <label for="" className="form-item__text">类型</label>
              </div>
              <div className="form-item__control form-item__control_is-readonly">
                <input type="text" className="u-input" value={pageType} readOnly />
                <span className="form-item__bottom-line"></span>
                <span className="form-item__right-icon">
                  <i className="u-icon pc-sys-bukebianji-nomal-svg"></i>
                </span>
              </div>
            </div>
          </li>
          <li>
            <div className="form-item">
              <div className="form-item__title">
                <label for="" className="form-item__text">描述</label>
              </div>
              <div className="form-item__control form-item__control_has-info">
                <span className="u-textarea">
                  <textarea className="u-textarea__element"
                    onChange={(e) => this.onInputChange(e, 'describe',250) }
                    placeholder='描述信息，限制长度250'
                    value={describe}/>
                  <span className="form-item__bottom-line"></span>
                  <span className="u-textarea__tuozhuai-icon">
                    <i className="u-icon pc-sys-tuozhuai-nomal-svg"></i>
                    <i className="u-icon pc-sys-tuozhuai-active-svg"></i>
                  </span>
                </span>
              </div>
            </div>
          </li>
        </ul>
      </div>
  }
}
