import React, { Component } from 'react';
import CommonPop from "@beisen/common-pop"

/*
* 重写CommponPop Save 函数，实现切换from表单, 和功能按钮
*/
export default class CustomPopView extends CommonPop {
  //确定
  handelEnter(e) {
    let self = this
    const {removeCommonPop, submitPop, animation, subBtnDisabled} = this.props
    if(subBtnDisabled) return
    setTimeout(function() {
      removeCommonPop && removeCommonPop()
      submitPop({
          target: e,
          value: self.state.getValue,
          status: "submit"
        })
    }, 300)
  }

  //取消 关闭
  handelCancel(e) {
    let self = this
    const {removeCommonPop, closePop, animation, cloBtnDisabled} = this.props
    if(cloBtnDisabled) return
    setTimeout(function() {
      removeCommonPop && removeCommonPop();
      closePop({
          target: e,
          "status": "close"
        })
    }, 300);
  }
  onClosePopUp(e) {
    this.handelCancel(e);
  }

  render() {
    let Header, Footer, content, Mask, self = this;
    let width = this.getWidth();
    let marginLeft = Math.ceil(width) / 2 * -1;
    const {hasHeader, hasFooter, hasRender, title, dataType, data, style, hidden, animation,showMask
      ,subBtnShow=true, subBtnText, cloBtnShow=true, cloBtnText, contentOffsetTop} = this.props;
    const {customStyle} = this.state;
    let offsetTop = contentOffsetTop ? contentOffsetTop : this.state
    const sty = {"top": offsetTop, width:width+"px",height:"170px","marginTop":"-140px","marginLeft":marginLeft+"px"};
    if(hasHeader) {
      Header = <div className="modal-pop__header">
                <div className="modal-pop__title">
                  {title}
                </div>
              </div>
    }
    if(hasFooter) {
      Footer = <div ref="popFooter"  className="btn-group modal-pop__footer">
                {this.state.footerContent}
                { cloBtnShow ?<button style={{"marginRight":(subBtnShow?"":"20px")}} className="btn btn_weaken" onClick={this.onClosePopUp}>{cloBtnText}</button>:""}
                { subBtnShow ?<button className="btn btn_default" onClick={this.handelEnter}>{subBtnText}</button>:""}
              </div>
    }

    if (dataType == "component" && this.props.PopComponent) {
      content = hasRender ? self.props.PopComponent : <self.props.PopComponent data = {data} {...data}/>
    }else {
      content = data
    }

    if(showMask){
      let pop = document.getElementsByClassName("modal-pop");
      let color;
      color = pop && pop.length>1 ? "transparent":"#03101A";
      Mask =  <div className="modal-pop__mask" style={{"backgroundColor":color,"display":"none"}}></div>
    }

    if(hidden) {
      return <div> </div>;
    }else {
      return (
        <div className="modal-pop" style={customStyle} >
          <div ref = "PopWindow"  className={"modal-pop__container modal-pop_is-open "+(animation || animation == undefined ?'a-modal-pop':'')} style = {sty} >
            {Header}
            <div className="modal-pop__content" ref="popContent" onScroll={ this.handleWheel.bind(this) }>
              {content}
            </div>
            {Footer}
          </div>
          {Mask}
        </div>
      )
    }
  }
}
