import React, { Component } from 'react';
import { connect } from 'react-redux';

import CustomPopView from "./custom-pop"

import PageCreaterForm from './create-page-form'
import SelectTemplateForm from './select-template-form'

import '../../../../src/components/basis/page-creator/index.scss'

export default class PageCreater extends Component {

  constructor(props) {
    super(props)
    this.state = {}

    this.pageInfoData = undefined
    this.templateSelected = undefined
  }

  popNextStep = () => {
    this.props.nextStep(this.pageInfoData)
  }

  popViewSave = () => {
    /* 选择模板验证 */
    if (!this.templateSelected || !this.pageInfoData) return false
    this.props.onSave({
      'pageInfo': this.pageInfoData,
      'templateSelected': this.templateSelected
    })
  }

  popViewPrevStep = () => {
    this.props.prevStep()
  }

  onPageFromChange = (formData) => {
    this.pageInfoData = formData
  }

  onTemplateSelected = (obj) => {
    this.templateSelected = obj
  }

  render() {

    let defaultProps = {
      'dataType': 'component',
      'hasFooter': true,
      'hasHeader': true,
      'showMask': true
    }
    /* 更具step初始化表单 */
    if (this.props.currentStep == 'createPage') {

      let cratePageForm =
        <PageCreaterForm 
          data={this.props.pageForm}
          onValuesChange={this.onPageFromChange}
          { ...this.props.formValidate }/>

      Object.assign(defaultProps, {
        'title': '创建',
        'data': cratePageForm,
        'cloBtnShow': false,
        'subBtnText': '下一步',
        'submitPop': this.popNextStep
      })

    } else {

      let selectLayoutForm = <SelectTemplateForm 
        data={this.props.templateForm} 
        onSelected={this.onTemplateSelected}
        getTemplateList={this.props.getTemplateList}/>

      Object.assign(defaultProps, {
        'title': '选择布局',
        'data': selectLayoutForm,
        'subBtnText': '完成',
        'cloBtnText': '上一步',
        'submitPop': this.popViewSave,
        'closePop': this.popViewPrevStep
      })
    }

    return <div className="pg-page-creater-container">
        <CustomPopView { ...defaultProps } />
        {
          this.props.error ?
            <span className="pg-ctpe-status">{ this.props.error.message }</span> : ''
        }
      </div>
  }
}
