import React, { Component } from 'react';
import { connect } from 'react-redux';
import List from '@beisen/transfer/lib/list'

import '../../../../components/basis/page-creater/SelectTemplateForm/index.css'
import '../../../../components/basis/page-creater/SelectTemplateForm/upaas-layout-one-column.svg'

export default class CreatePage extends Component {

  constructor(props) {
    super(props)
    this.state = {
      'currentTab': this.props.data.hasTemplate ? 'template' : 'layout',
      'selectedItem': {}
    }
  }

  onChangeTab (tabType) {
    this.setState({
      'currentTab': tabType,
    })
  }

  onItemClick = (itemFlag, selectedItem) => {
    this.setState({ 'selectedItem': selectedItem })
    this.props.onSelected({
      'type': this.state.currentTab,
      'item': selectedItem
    })
  }

  componentDidMount () {
    this.props.getTemplateList()
  }

  render() {
    let { currentTab, selectedItem={} } = this.state
    let { layouts=[], templates=[], hasTemplate } = this.props.data

    for (let layout of layouts) {
      layout.active = false
      if (currentTab == 'layout' && layout.value == selectedItem.value) {
        layout.active = true
      }
    }  

    for (let temp of templates) {
      temp.active = false
      if (currentTab == 'template' && temp.value == selectedItem.value) {
        temp.active = true
      }
    }

    let { 'value': selectedItemValue } = selectedItem

    return <div className="pg-select-layout-container">
        <div className={ hasTemplate ? 'tab pg-slat-tab' : 'pg-slat-tab' }>
          {
            hasTemplate ? <div><ul className="list_horizontal list_wrap tab__list">
              <li
                className={ currentTab == 'template' ? 'tab__item tab__item_is-active' : 'tab__item' }
                onClick={ () => { this.onChangeTab('template') } }>
                基于模板
              </li>
              <li
                className={ currentTab == 'layout' ? 'tab__item tab__item_is-active' : 'tab__item' }
                onClick={ () => { this.onChangeTab('layout') } }>
                基于布局
              </li>
            </ul>
            <div className="tab__line" style={{
              width: '80px',
              left: currentTab == 'template' ? '1px' : '84px'
            }}></div></div> : null
          }
          <div className="pg-slat-tab-content transfer__container">
            <div className="transfer__content">
              {
                currentTab == 'template' ?
                  <ul>
                    {
                      templates.map(item =>
                        <li key={item.value} className={ item.active ? 'transfer__item active' : 'transfer__item' }
                          onClick={ (e) => { this.onItemClick('template', item) } }>
                          <span className="transfer__text">{ item.label }</span>
                        </li>
                      )
                    }
                  </ul> :
                  <ul>
                    {
                      layouts.map(item =>
                        <li key={item.value} className={ item.active ? 'transfer__item active' : 'transfer__item' }
                          onClick={ (e) => { this.onItemClick('layout', item) } }>
                          <span className="transfer__text">{ item.label }</span>
                        </li>
                      )
                    }
                  </ul>
              }
            </div>
          </div>
        </div>
        <div className="pg-slat-contnet">
          <span className={ `pg-slat-layout-icon ${selectedItemValue}` } />
        </div>
      </div>
  }
}
