import React, { Component, PropTypes } from 'react'
import ToolTip from '@beisen/tool-tip'
import '../../../../src/components/basis/prop-cmp-label/index.css'
import '../../../../src/components/basis/prop-cmp-label/quest1.png'

export default class extends Component {

  render () {
    let { label, validation=[], description=[] } = this.props
    if (!label) return <div></div>

    let validateKeys = validation.map(({ type }) => type)
    let required = validateKeys.includes('required')

    let hasDescription = !!description.length
    let title = description.map(({ text='' }) => text).join('')

    return <div className='pg-props-label'>

      <label className={ required ? 'pg-prop-common-label pg-prop-common-label-required' : 'pg-prop-common-label' }>
        { label }
      </label>

      {
        hasDescription ? <ToolTip title={ title }>
            <span className='pg-pla-description'></span>
          </ToolTip> : null
      }
    </div>
  }
}
