import { Component } from 'react'
import { selectedItem } from '../../helpers/collection-picker'

export default class extends Component {
  constructor (props) {
    super(props)
    this.state = {
      'selected': ''
    }
  }

  onChangeHandler = (e) => {
    this.setState({ 'selected': e.target.value })
    this.props.onChange({ 'value': e.target.value })
  }

  render () {
    let {
      items=[], selected, label
    } = this.props

    selected = this.state.selected || selected

    if (selected) {
      items = selectedItem(items, { 'value': selected })  
    }

    return (

      <div className='default-setting-wrapper pg-prop-select'>
        <div>{ label }</div>
        <select onChange={ this.onChangeHandler } value={ selected } >
          {
            items.map(({ label, value }) => 
              <option value={ value } key={ value }>{ label }</option>
            )
          }
        </select>
      </div>
    )
  }
}
