import { Component } from "react"
import '../../../../../src/components/elements/basis/tab/index.scss'

export default class TabContainer extends Component {
  static componentHolder = true
  constructor (props) {
    super(props)

    /* 使用defaultTab初始化第一次加载页面时的高亮tab */
    let { tabConfig={} } = this.props.data || {}
    let { defaultTab='', isActiveFirstItem, tabItemList=[] } = tabConfig
    
    if (isActiveFirstItem && tabItemList.length) {
      defaultTab = tabItemList[0].value || ''
    }
    
    this.state = { 'currentTab': defaultTab }
  }

  handleSwitchTab = (currentTab) => (e) => {
    this.setState({ currentTab })
  }

  getCurrentTabBySelectedCmp () {
    let {
      '_subComponents': subComponents=[],
      '_selectedComponent': selectedComponentId, } = this.props
    if (!selectedComponentId || !subComponents || !subComponents.length) return null

    for (let { componentHolderKey, id } of subComponents) {
      if (selectedComponentId == id) {
        return componentHolderKey
      }
    }
    return null
  }

  render() {
    let {
      connectPlaceholder,
      data={},
    } = this.props

    let { tabConfig={} } = data
    let { tabItemList=[], defaultTab } = tabConfig

    let [ firstItem={} ] = tabItemList
    let { 'value': fistItemValue='' } = firstItem
    
    let currentTab = this.state.currentTab || fistItemValue

    /* 通过 被选中的 组件 激活，所在 item 并 高亮 */
    let selectedCmpTabName = this.getCurrentTabBySelectedCmp()
    if (selectedCmpTabName && selectedCmpTabName !== currentTab) {
      currentTab = selectedCmpTabName
    }

    return <div className='component-holder'>
      <div className='tab'>
        <ul className='tab-title list_horizontal list_wrap tab__list'>
          {
            tabItemList.map(({ label, value }, index) => {
              let active = (currentTab === value) ? true : false
              let className = active ? ' tab__item_is-active' : ''
              return <li key={ index } 
                onClick={ this.handleSwitchTab(value) } 
                className={ `tab__item s-tab ${className}` }>
                  { label }
              </li>
            })
           }
        </ul>
      </div>
      { connectPlaceholder(currentTab)(<div></div>) }
    </div>
  }
}
