import React, { Component } from 'react'
import { checkItems } from '../../../../helpers/collection-picker'
import CheckboxList from '../../../basis/checkbox-list'
import '../../../../../src/components/properties/basis/checkbox-list/index.css'

export default class extends Component {
  componentDidMount () {
    let {
      defaultValueNeedUpdate
    } = this.props
    if (defaultValueNeedUpdate)
      this.props.updateSilent({ 'items': [], 'values': '' })
  }

  onChange = (selectedItems) => {
    let values = selectedItems.map(({ value }) => value)
    this.props.update({ values, 'items': selectedItems })
  }

  render () {
    let {
      data={},
      'attributes': {
        'props': {
          'items': totalItems=[],
        }
      }
    } = this.props

    let { values=[] } = data
    return <CheckboxList items={ totalItems } checked={ values } onChange={ this.onChange } />
  }
}
