import React, { Component } from 'react'
import CommonPop from "@beisen/common-pop"
import EventsPicker from './eventsPicker'

export default class extends Component {
  constructor (props) {
    super(props)
    this.state = {
      'showEditor': false,
      'editItems': {}
    }
    this.eventsPickerData
  }

  popViewSave = () => {
    let {
      selectedTargetEvent = {},
      selectedActiveCmpEvent = {},
      eventParams = {}
    } = this.eventsPickerData

    let { data: events = {} } = this.props

    Object.assign(events, {
      [selectedTargetEvent.name]: [{
        'type': selectedActiveCmpEvent.name,
        'params': {
          ...eventParams
        }
      }]
    })

    this.props.update(events)
    this.setState({ 'showEditor': false })
  }

  popViewClose = () => {
    this.setState({ 'showEditor': false })
  }

  onEditClickHandler = () => {
    this.setState({ 'showEditor': true })
  }

  onEventsPickerChange (state) {
    this.eventsPickerData = state
  }

  onEventEditClick (e, event) {
    this.setState({ 'showEditor': true })
  }

  render () {
    let {
      pageState,
      data: events = {} } = this.props

    let { showEditor, editItem } = this.state
    let { targetClassId, targetEvents } = this.props.attributes.props

    let eventPicker = <EventsPicker
      data={ editItem }
      pageState={ pageState }
      targetClassId={ targetClassId }
      targetEvents={ targetEvents }
      onChange={ this.onEventsPickerChange.bind(this) }
    />

    return <div className='pg-events-editor'>
      <div className="pg-events-readonly-container">
        {
          Object.keys(events).map(eKey => {
            return <div className="pg-events-read-item" onClick={ (e) => { this.onEventEditClick(e, { name: eKey, label: events[eKey].label }) } }>
              { targetEvents[eKey].label } ({ eKey })
            </div>
          })
        }
      </div>
      <div className="pg-events-editor-edit-container">
        <span className="ui-icon sys-icon-IM-bianji pg-events-editor-edit" onClick={ this.onEditClickHandler }></span>
      </div>
      {
        showEditor ? <CommonPop
          title={ '配置事件' }
          dataType={ 'component' }
          hasFooter={ true }
          hasHeader={ true }
          showMask={ true }
          data={ eventPicker }
          submitPop={ this.popViewSave }
          closePop={ this.popViewClose } /> : null
      }
    </div>
  }
}
