import React, {Component, PropTypes} from 'react'
import UmRichEditor from '@beisen/um-rich-editor'
import '../../../../../src/components/properties/basis/rich-editor-text/index.css'

export default class RichEditor extends Component {
  constructor (props) {
    super(props)
    this.richId = 'pg-props-rich-editor' + (new Date()).getTime()
  }

  onEditorChange = (value, haveContent) => {
    this.props.update(value)
  }

  render () {
    let value = this.props.data || ''
    
    let { validateStatus={} } = this.props.attributes.props
    let { 'message': errMsg, valid } = validateStatus

    return <div>
      <UmRichEditor
        id={ this.richId }
        value={value}
        name={''}
        errorStatus={false}
        errorMsg={''}
        helpMsg={''}
        sideTip={false}
        hiddenTip={false}
        editStatus={true}
        onChange={this.onEditorChange}
      />
      { !valid ? <span className="pg-prop-error-text">{ errMsg }</span> : null }
    </div>
  }
}
