import React, { Component } from 'react'
import { selectedItem } from '../../../../helpers/collection-picker'
import DropdownList from '../../../basis/dropdown-list'
import '../../../../../src/components/properties/basis/select/index.scss'

export default class Select extends Component {
  componentDidMount () {
    let { defaultValueNeedUpdate } = this.props
    
    let currentSelected = this.getCurrentSelectedItem()

    if (defaultValueNeedUpdate) this.props.updateSilent(currentSelected)
  }

  onChange = (selectedItems) => {
    let [ firstItem={} ] = selectedItems
    let { value } = firstItem
    this.props.update(value)
  }

  /*
  * 通过 value, selected, defaultSelectedIndex 确定当前选中的item
  */
  getCurrentSelectedItem () {
    let {
      'data': value,
      'attributes': {
        'props': {
          items=[],
          selected,
          defaultSelectedIndex, /* 如果没有任何选中的item，可以通过该字段来设置默认选中的节点在items中的下标 */
        }
      }
    } = this.props

    let currentSelected = undefined

    if (!value) {
      if (!selected) {
        if (defaultSelectedIndex >= 0) {
          let defaultSelectedItem = items[defaultSelectedIndex]
          let { 'value': firstItemValue } = defaultSelectedItem
          currentSelected = firstItemValue
        }
      } else {
        currentSelected = selected
      }
    } else {
      currentSelected = value
    }

    return currentSelected
  }

  render () {
    let {
      'attributes': {
        'props': {
          items=[],
          disabled=false,
          validateStatus={}
        }
      }
    } = this.props
    
    let { 'message': errMsg, valid } = validateStatus

    let currentSelected = this.getCurrentSelectedItem()
    currentSelected = currentSelected ? [currentSelected]: []

    return <div className='pg-prop-select'>
      <DropdownList items={ items } selected={ currentSelected } onChange={ this.onChange } disabled={ disabled } />
      { !valid ? <span className="pg-prop-error-text">{ errMsg }</span> : null }
    </div>
  }
}
