import { Component } from 'react'
import Item from './tab-item'
import '../../../../../../src/components/properties/basis/tab-item-creator/TabItemList/index.css'

export default class extends Component {

  constructor (props) {
    super(props)
    this.state = {}
  }

  onItemUpdate (targetValue, { value, label, code }) {
    let { items } = this.props
    items = items.map(item => {
      if (targetValue === item.value){
        item = Object.assign({}, item, { value, label, code })
      }
      return item
    })
    this.props.onChange(items)
  }

  onItemDelete (targetValue) {
    let { items } = this.props
    items = items.filter(({ value }) => targetValue !== value)
    this.props.onChange(items)
  }

  onItemSort (targetValue, { direction }) {
    let { items } = this.props
    
    let targetIndex = -1
    for (let i=0; i<items.length; i++) {
      if (items[i].value == targetValue) {
        targetIndex = i
        break
      }
    }

    if (direction == 'top') {
      if (targetIndex == 0) return

      items.splice(
        targetIndex-1, /* 开始删除的节点下标 */
        2, /* 向后删除2个节点 */
        items[targetIndex], /* 被前移的节点 */
        items[targetIndex-1] /* 被后置的节点 */
      )

    } else if (direction == 'down') {
      if (targetIndex == items.length-1) return

      items.splice(targetIndex, 2, items[targetIndex+1], items[targetIndex])
    }

    this.props.onChange(items)
  }

  render () {
    let { items } = this.props

    return <div className='pg-prop-tab-list'>
      <ul>
        {
          items.map(({ label, value, code }, index) => {
            return <Item 
                    key={ value }
                    label={ label }
                    value={ value }
                    code={ code }
                    currentIndex={ index }
                    onUpdate={ ::this.onItemUpdate }
                    onDelete={ ::this.onItemDelete }
                    onSort={ ::this.onItemSort }
                    checkCodeRepeat={ this.props.checkCodeRepeat }
                  />
          })
        }
      </ul>
    </div>
  }
}
