import { Component } from 'react'
import TabItemEditor from './../TabItemEditor'

import '../../../../../../src/components/properties/basis/tab-item-creator/TabItemList/images/sort-top.png'
import '../../../../../../src/components/properties/basis/tab-item-creator/TabItemList/images/sort-down.png'
import '../../../../../../src/components/properties/basis/tab-item-creator/TabItemList/images/tab-edit.png'

export default class extends Component {

  constructor (props) {
    super(props)
    this.state = {
      'editViewShow': false
    }
  }

  onDeleteClickHandler () {
    let { value } = this.props
    this.props.onDelete(value)
  }

  onEditClickHandler () {
    this.setState({ 'editViewShow': true })
  }

  onEditorUpdate ({ label, value, code }) {
    this.setState({ 'editViewShow': false })
    let { 'value': oldValue } = this.props
    this.props.onUpdate(oldValue, { label, value, code })
  }

  onEditorCancel () {
    this.setState({ 'editViewShow': false })
  }

  onSortClickHandler (direction) {
    let { 'value': currentValue } = this.props
    this.props.onSort(currentValue, { direction })
  }

  render () {
    let { label, code, value, currentIndex } = this.props
    let { editViewShow } = this.state

    return (
      <li className="pg-prop-tab-item">
        
        <div className="ppti-sort ppti-item">
          <span className="ppti-sort-top sys-icon-arrowup-nomal" onClick={() => { ::this.onSortClickHandler('top') }}></span>
          <span className="ppti-sort-down sys-icon-arrowdown-nomal" onClick={() => { ::this.onSortClickHandler('down') }}></span>
        </div>

        <div className="ppti-label ppti-item">
          <span className="ppti-label-index">{ label }</span>
          <span className="ppti-label-text">{ code }</span>
        </div>
        
        <div className="ppti-edit ppti-item" onClick={ ::this.onEditClickHandler }>
          <span className="ppti-edit-icon sys-icon-IM-bianji"></span>
        </div>

        <div className="ppti-delete ppti-item" onClick={ ::this.onDeleteClickHandler }>
          <span className="ppti-delete-icon sys-icon-close"></span>
        </div>

        {
          editViewShow ?
          <TabItemEditor
            value={ value }
            code={ code }
            label={ label }
            onSaveClickHandler={ ::this.onEditorUpdate } 
            onCancelClickHandler={ ::this.onEditorCancel }
            checkCodeRepeat={ this.props.checkCodeRepeat } /> : null
        }
      </li>
    )
  }
}
