import React, {Component, PropTypes} from 'react'
import '../../../../../src/components/properties/basis/text/index.css'

export default class extends Component {
  componentDidMount () {
    let {
      defaultValueNeedUpdate,
      'attributes': { 'props': { value='' } }
    } = this.props

    if (defaultValueNeedUpdate) this.props.updateSilent(value)
  }

  onChange = (e) => {
    this.props.update(e.target.value)
  }

  render () {
    let {
      'data': value='',
      'attributes': {
        'props': {
          validateStatus={}
        }
      },
    } = this.props

    let { 'message': errMsg, valid } = validateStatus

    return <div>
      <input
        className={ valid ? 'pg-props-input' : 'pg-props-input pg-props-input-error' }
        value={ value }
        placeholder='空白内容'
        onChange={ this.onChange } />
      { !valid ? <span className="pg-prop-error-text">{ errMsg }</span> : null }
    </div>
  }
}
