import React, { Component } from 'react'
import '../../../../../src/components/properties/basis/textarea/index.scss'

export default class extends Component {
  componentDidMount () {
    let {
      defaultValueNeedUpdate,
      'attributes': { 'props': { value='' } }
    } = this.props

    if (defaultValueNeedUpdate) this.props.updateSilent(value)
  }

  handleChange = (e) => {
    this.props.update(e.target.value)
    this.props.onChange && this.props.onChange(e.target.value)
  }
   
  render(){
    let {
      'data': value='',
      'attributes': {
        'props': {
          validation={},
        },
      },
    } = this.props

    let { required={} } = validation
    let { 'message': errMsg, valid=true } = required

    return <div>
        <textarea
          type='text'
          className={ valid ? 'pg-props-textarea' : 'pg-props-textarea pg-props-textarea-error' }
          placeholder='空白内容'
          value={value}
          onChange={this.handleChange}
        />
        { !valid ? <span className="pg-prop-error-text">{ errMsg }</span> : null }
      </div>
  }
}
