import required from './required'
import maxLength from './maxLength'
import format from './format'
import relatedExpRequired from './relatedExpRequired'
import comparePropDataUnique from './comparePropDataUnique'

let validates = {
  required, maxLength, format, relatedExpRequired,
  comparePropDataUnique
}

export default validates

export const injectValidatesScope = (...scope) => {
  Object.keys(validates).forEach(name => {
    let oriValidate = validates[name]
    validates[name] = function (...args) {
      return oriValidate(...scope, ...args, )
    }
  })
}

export const installValidates = (insValidates) => {
  Object.keys(insValidates).forEach(name => {
  	validates[name] = insValidates[name]
  })
}
