export default (state, data = {}, params = {}, { filterParser, filterObjValuesParser }) => {
  let { validateRules=[] } = params

  if (validateRules.length) {
    let res = true
    
    for (let rule of validateRules) {
      res = filterParser(rule, { 'propData': data })
      if (!res) break
    }
    
    if (!res) return false
    return true
  } else {

    /* 通用验证规则 */
    if (typeof data == null) {
      return false
    } else if (typeof data == 'undefined') {
      return false
    } else if (typeof data == 'object') {
      if (Object.keys(data||{}).length) return true
      return false
    } else if (typeof data == 'array') {
      if (data.length) return true
      return false
    } else {
      return !!data
    }
  }  
}
