import queryParams from './queryParams'
import searchParams from './searchParams'
import urlParams from './urlParams'
import activeComponents from './activeComponents'

let contexts = {
  queryParams,
  searchParams,
  urlParams,
  pageLayout: function () {},
  pageInfo: function () {},
  activeComponents
}

export default contexts

export const injectContextsScope = (...scope) => {
  Object.keys(contexts).forEach(name => {
    let oriContexts = contexts[name]
    contexts[name] = function (...args) {
      return oriContexts(...args, ...scope)
    }
  })
}

export const installContexts = (insContexts) => {
  Object.keys(insContexts).forEach(name => {
    contexts[name] = insContexts[name]
  })  
}
