export function mergeItems (baseItems, mergedItems) {
  if (!baseItems || !baseItems.length) return []
  if (!mergedItems || !mergedItems.length) return baseItems

  let resItems = []
  for (let item of baseItems) {
    for (let mItem of mergedItems) {
      /* value 相同 则覆盖 */
      if (item.value == mItem.value) {
        item = mItem
        break
      }
    }
    resItems.push(item)
  }
  return resItems
}

export function selectedItem (items, { value }) {
  if (!value) return items
  if (!items) return []

  let resItems = []
  for (let item of items) {
    let resItem = Object.assign({}, item)
    if (item.value == value) {
      resItem.selected = true
    }
    resItems.push(resItem)
  }
  return resItems
}

export function getItem (items=[], { value }) {
  if (!value) return {}

  let resItems = []
  let resItem = null

  for (let item of items) {
    if (item.value == value) {
      return item
    }
  }
}

export function checkItems (items, { values=[], 'items': selectedItems }) {
  if (!items) return []

  let resItems =[]
  
  if (!values.length && selectedItems) {
    for (let { value } of selectedItems) values.push(value)
  }

  for (let item of items) {
    let resItem = Object.assign({}, item)
    if (values.includes(item.value)) {
      resItem.checked = true
    }
    resItems.push(resItem)
  }
  return resItems
}
