import { parseFilters, parseText } from './vue-filter-parser'
import { compile as EJSCompiler } from './ejs'
import { resolveFilter } from './filters'
import basedContexts from '../../contexts'

const parse = (filterString = '', excuteContext = {}) => {
  if (!filterString || typeof filterString !== 'string') {
    return filterString
  }
  /* 转换函数类型的context成可用对象变量 */
  let basedContextsObj = excFunContextToObject(basedContexts)
  /* resolveFilter：获取 filter 的工厂函数 */
  Object.assign(excuteContext, { resolveFilter, ...basedContextsObj })
  // filterString = filterString.replace(/^\s*{{\s*|\s*}}\s*$/g, '')
  let parsedFilterString = parseText(filterString);
  /* 使用 ejs 插件处理模板，可返回复杂对象(非字符串) */
  let [ value ] = EJSCompiler(`<%= ${parsedFilterString} %>`)(excuteContext)
  return value
}

export default parse

export const parseObjValues = (obj = {}, excuteContext = {}) => {
  let res = {}
  Object.keys(obj).forEach(objKey => {
    res[objKey] = parse(obj[objKey], excuteContext)
  })
  return res
}

function excFunContextToObject (contexts) {
  let resObject = {}
  Object.keys(contexts).forEach(contextKey => {
    let val = (typeof contexts[contextKey] === 'function') ? contexts[contextKey]() : contexts[contextKey]
    resObject[contextKey] = val
  })
  return resObject
}
