/*
* 异步模块需要调用的函数，返回异步模块
*/
import exportModuleManager from './exportModuleManager'

// 默认值
const _defaultModule = {
  'components': [],
  'modules': {
    'actions': {},
    'getters': {},
    'mutations': {},
    'state': {}
  }
}

/**
* 异步模块中调用改函数，把模块写入队列, 所有模块会在 scirpt.onload 时全部返回
* {
*   components: [Vue Component Class List],
*   modules: {
*     actions: {},
*     getters: {},
*     mutations: {},
*     state: {}
*   }
* }
**/
export default function (module) {
  let m = Object.assign({}, _defaultModule, module)
  exportModuleManager.add(m)
}
