
export function getRouter () {
  let loc = document.location
  let hash = loc.hash.match(/^[#]{0,1}[\/]{0,1}([\s\S]+?)($|\?[\s\S]+)/)[1]
  return {
    'hash': hash,
    'host': loc.host,
    'hostname': loc.hostname,
    'href': loc.href,
    'origin': loc.origin,
    'pathname': loc.pathname,
    'port': loc.port,
    'protocol': loc.protocol
  }
}

export function getQueryParams () {
  let loc = document.location
  let resQuery = {}
  let queryStringExp = (loc.hash || '').match(/\?([\s\S]+)$/)
  if (queryStringExp) {
    let queryString = queryStringExp[1]
    let queryStrList = queryString.split('&')
    queryStrList.forEach(function (queryStr) {
      let que = queryStr.split('=')
      resQuery[que[0]] = decodeURIComponent(que[1])
    })
    return resQuery
  } else {
    return resQuery
  }
}

export function navigation (linkTo) {
  document.location.hash = linkTo
}

export function getSearchParams () {
  let loc = document.location
  let resSearchParams = {}
  let searchString = loc.search.slice(1, loc.search.length)
  let searchStrList = searchString.split('&')
  searchStrList.forEach(function (searchStr) {
    let que = searchStr.split('=')
    resSearchParams[que[0]] = decodeURIComponent(que[1])
  })
  return resSearchParams
}

export function getUrlParams() {
  let searchParams = getSearchParams()
  let qureyParams = getQueryParams()
  return Object.assign({}, searchParams, qureyParams)
}

export function getParam(key) {
  let query = getQueryParams()
  if (query[key]) return query[key]
  let search = getSearchParams()
  if (search[key]) return search[key]
}
