
export default (tubState) => {
  let cmpsTree = []
  
  let cmpList = tubState.componentList.map(item => {
      return Object.assign({}, item, { children: [] })
  })
  
  let sectionIds = tubState.sectionList.map(function(item) {
    return item.id
  })

  let map = {}, cmp;
  for (let i = 0; i < cmpList.length; i++) {
    cmp = cmpList[i];
    map[cmp.id] = i
    // 非根节点组件 
    if (sectionIds.indexOf(cmp['parentId']) < 0) {
      cmpList[map[cmp['parentId']]].children.push(cmp)
    } else {
      /* 根节点组件 */
      cmpsTree.push(cmp)
    }
  }

  //依据sectionIds 重排序
  cmpsTree = sectionIds.map(item => {
    let index = cmpsTree.findIndex(component => component['parentId'] == item);
    return cmpsTree[index]
  })

  return cmpsTree
}
