import { upaasCmpTransfer } from './layoutParser/index'
import excuteOnSubmit from './onSubmit'
import createCmpsTree from './createCmpsTree'

export default function parse (tubState, state) {
  return excuteOnSubmit(tubState, state, (newTubState) => {
    let cmpsTree = createCmpsTree(newTubState)
  
    /* pageBuilder 组件转化为 upaas组件 1对多 的关系 */
    let upaasCmps = (function _self (cmpsTree) {
      let resUpaasCmps = []
      let children = []
      
      for (let i = 0; i < cmpsTree.length; i++) {
        let pgCmp = cmpsTree[i]
        
        /* 递归开始 */
        if (pgCmp.children && pgCmp.children.length) {
          pgCmp.children = _self(pgCmp.children)
        }

        /* 生成 upaas 组件元数据 */
        let upaasCmpData = upaasCmpTransfer(pgCmp, state)

        resUpaasCmps.push(upaasCmpData)
      }

      return resUpaasCmps
    })(cmpsTree)
    
    let pageSettingUpaasCmpData = upaasCmpTransfer(newTubState.pageSettings, state)

    let pageLayout = { ...pageSettingUpaasCmpData, 'children': upaasCmps }

    return { 'layout': pageLayout, 'page': newTubState }
  })
}
