
const genUpaasCmpProps = (pBuilderCmp = {}) => {
  let props = {}

  let { editableData = {} } = pBuilderCmp
  for (let eKey in editableData) {
    let eVal = editableData[eKey]
    props[eKey] = eVal
  }

  return props
}

export const upaasCmpTransfer = (pBuilderCmp = {}, state) => {
  /* pageBuilder 生成的 key 充当 upaas元数据的 slot */
  let { 'componentHolderKey': slot, classId } = pBuilderCmp

  let props = genUpaasCmpProps(pBuilderCmp)

  /* 不定结构都需要转成字符串 */
  let {
    events = props.events || {},
    // engine = JSON.stringify({}),
    // container = {}
  } = {}

  /*
  * 事件放在props的平级，删除props中的events
  */
  delete props.events

  let { cmpsMetadatas } = state
  let name = cmpsMetadatas[classId].name

  let { id, type, children = [] } = pBuilderCmp

  let upaasCmpData = {
    id,
    name,
    type,
    'attributes': {
      props,
      slot,
      events
    },
    children,
    // engine,
    // container
  }

  return upaasCmpData
}
