import filterParser, { parseObjValues as filterObjValuesParser } from '../../helpers/filterParser'

let getValueFromPath = (value, paths='') => {
  if (!value) return null
  let targetValue = value
  paths.split('|').forEach(pathItemKey => {
    targetValue = targetValue[pathItemKey]
  })
  return targetValue
}


export default (tubState, cmpMetaData, params) => {
  let dataSource =[]

  let { dataSourceGetter } = params
  if (!dataSourceGetter) dataSourceGetter = params

  let { editableData={} } = cmpMetaData

  for(let { key='', value='' } of dataSourceGetter) {
    value = filterParser(value, { ...editableData })
    dataSource.push({ 'key': key, 'value': value })
  }

  /* 在组件元数据中追加 dataSource */
  let matched = false
  let { componentList=[], pageSettings } = tubState
  for (let tubCmp of componentList) {
    let { id } = tubCmp
    if (id == cmpMetaData.id) {
      tubCmp['dataSource'] = dataSource
      matched = true
    }
  }
  tubState.componentList = componentList

  if (!matched && pageSettings.id == cmpMetaData.id) {
    tubState.pageSettings['dataSource'] = dataSource
  }

  return tubState
}
