const isExternalTabCmp = (tubState, tabCmpMetaData) => {
  let { parentId } = tabCmpMetaData
  let { componentList=[], sectionList=[] } = tubState
  let sections = sectionList.map(({ id }) => id)
  return sections.includes(parentId)
}

const dynamicTotalCmpChildren = function _self (tubState, cmpMetaData) {
  let { componentList=[] } = tubState
  let { editableData={}, 'id': cmpId } = cmpMetaData

  for (let cmp of componentList) {
    let { parentId, name } = cmp

    if (parentId == cmpId) {
      cmp.isDynamicComponent = true   
      /* 如果子节点是一个Tab组件，则递归 */
      if (name == 'upaas-tab-container') {
        tubState = _self(tubState, cmp)
      }
    }
  }
  return tubState
}

const dynamicTotalUnActiveCmpChildren = function _self (tubState, cmpMetaData) {
  let { componentList=[] } = tubState
  let { editableData={}, 'id': cmpId } = cmpMetaData
  let { 'tabConfig': { defaultTab='' } } = editableData

  for (let cmp of componentList) {
    let { parentId, name, componentHolderKey } = cmp
    if (parentId == cmpId) {
      
      if (componentHolderKey != defaultTab) {
        cmp.isDynamicComponent = true

        /* 如果子节点是一个Tab组件，则递归 */
        if (name == 'upaas-tab-container') {
          tubState = _self(tubState, cmp)
        }
      }
    }
  }
  return tubState
}

export default (tubState, tabCmpMetaData) => {
  if (!isExternalTabCmp(tubState, tabCmpMetaData)) {
    return tubState
  }

  let { componentList=[] } = tubState
  let { editableData={}, 'id': tabContainerId } = tabCmpMetaData
  let { 'tabConfig': { defaultTab='', isActiveFirstItem, tabItemList=[] } } = editableData

  if (isActiveFirstItem) {
    defaultTab = (tabItemList[0] || {}).value
  }

  for (let cmpMetaData of componentList) {
    let { parentId, componentHolderKey, name } = cmpMetaData
    if (parentId == tabContainerId) {

      if (componentHolderKey == defaultTab) {

        if (name == 'upaas-tab-container') {
          tubState = dynamicTotalUnActiveCmpChildren(tubState, cmpMetaData)
        }
      } else {
        cmpMetaData.isDynamicComponent = true
        if (name == 'upaas-tab-container') {
          tubState = dynamicTotalCmpChildren(tubState, cmpMetaData)
        }
      }
    }
  }

  return tubState
}
