
/*
* 格式化pgb生成的配置
* 1. 把componentList中组件的cType替换成type
* 2. 给pageSetting添加 id, classId, type, name 属性，和 component 元数据统一
*/
export default (tubState, state) => {
  let componentList = []
  /* 生成 cmpId - pgId one vs more 关系 */
  tubState.componentList.forEach(function(cmp) {
    let standardCmpData = toStandardCmpData(cmp)
    let { editableData, classId } = cmp
    componentList.push(standardCmpData)
  })

  tubState['componentList'] = componentList

  /* 添加页面组件的必要字段 */
  let { name, id, type, editableData } = state.pageComponent

  tubState.pageSettings['id'] = id /* 实例化id，页面类型的组件，使用cmp_id做为实例化id */
  tubState.pageSettings['classId'] = id /* 实例化组件 和 Cloud组件的对应关系 */
  tubState.pageSettings['type'] = type /* 组件类型 */
  tubState.pageSettings['name'] = name /* upaas组件的类型 */

  return tubState
}

const toStandardCmpData = (component) => {
  let { cType, ...restData } = component
  return { 'type': cType, ...restData }
}
